



                                       Preface


     The Version Control & Maintenance System is an application that allows
     either the client or the programmer to maintain their database of
     source code.  VCM is written in a dBASE IV compatible language called
     Foxpro.

     As a client, this system allows you to obtain the latest updated
     source code.  As a programmer, this system allows you to maintain
     another programmer's database of source code.  At the same time, other
     programmers can keep up with your modifications.  All without the need
     to "check-out" program files.

     For the VCM System to work, you must have a copy of PKWare's
     PKZIP/PKUNZIP utilities.  You also must have a modem and a PC-to-PC
     communication application.  I recommend at least a 9600 baud modem and
     a communication program such as PC Anywhere.

     An IBM personal computer (80386 or better) is recommended.  For
     improved performance, it is highly recommended that the user obtain at
     least three megabytes of extended memory.  A color monitor and a mouse
     are also recommended.

     Considerable effort was expended to make the user reference manual as
     complete as possible.  However, this documentation is in no way to be
     considered an instructive guide to MS-DOS, Foxpro, or PC-to-PC
     communications.  Many reference texts are available on the market that
     explain the MS-DOS operating system, Foxpro programming, and PC-to-PC
     communications.  If you need more information, your reference
     materials should include one of these texts.

     My advice is to read the contents of this user manual.  Familiarize
     yourself with its information.  If you have any questions concerning
     this application, feel free to write or call.























                                     - Page 1 -







                             Copyright/License/Warranty




     This document and the program Version Control & Maintenance ("the
     software") are copyrighted by the author.  The copyright owner hereby
     licenses you to use the software given these restrictions:


          o  the program shall be supplied in its original, unmodified
             form, which includes this documentation;

          o  for-profit use without a license is prohibited;

          o  the program may not be included - or bundled - with other
             goods or services.  Exceptions may be granted upon written
             request only.

          o  no fee is charged beyond a reasonable amount for the media
             and handling ($10 maximum suggested);


          There is no warranty of any kind.  The copyright owner may not
          be held liable for any damages, including any lost profits or
          other incidental or consequential damages arising out of or
          inability to use the software.  By using the software, you agree
          to this.


     Shareware

          VCM is distributed as Shareware.  It is not free software.
          You are free to try it and make copies for others.  If you
          continue to use this application beyond a reasonable trial
          period, you are required to register it with the distributor
          and author.


     ASP Ombudsman

          This program is produced by a member of the Association of
          Shareware Professionals (ASP).  ASP wants to make sure that the
          shareware principle works for you.  If you are unable to resolve
          a shareware-related problem with an ASP member by contacting the
          member directly, ASP may be able to help.  The ASP Ombudsman can
          help you resolve a dispute or problem with an ASP member, but
          does not provide technical support for members' products.

          Please write to the ASP Ombudsman at 545 Grover Road, Muskegon,
          MI 49442-9427 USA, FAX 616-788-2765 or send a CompuServe message
          via CompuServe Mail to ASP Ombudsman 70007,3536.



          Copyright (C) 1992 Dennis Allen.  All rights reserved.  All
          trademarks mentioned herein belong to their respective owners.

                                     - Page 2 -







                                  TABLE OF CONTENTS


     Preface                                                    1
     Copyright/License/Warranty                                 2
     Introduction                                               5
         Manual Content                                         5
         Notation Convention                                    6
     System Startup                                             7
         Client Overview                                        7
         Programmer Overview                                    7
         Host Start-up                                          8
         Creating REMOTE.ZIP                                   10
         Remote Start-up                                       10
         Updating VCM Paths                                    11
         Updating a VCM Path Record                            14
         Creating HOST.ZIP                                     15
         Host Restart                                          15
         Normal Operations                                     15
         Maintaining VCM records                               16
         ZIP Files                                             16
         Quit                                                  18
     Printing VCM Files                                        19
         Printing VCM Edit List                                19
         Printing VCM History Edit List                        20
         Printing VCM Path List                                21
         Check Translated Code                                 21
         Check Parameter Code                                  22
         Compare Host to Remote                                22
             File Comparison                                   23
         Quit                                                  23
     System Setup                                              24
         Expression Builder                                    25
         Printer Control Codes                                 26
         Change Color Set                                      28
             Customizing Color Sets                            28
         Problems & Suggestions                                28
         All About...                                          29
         Edit Data Path/File Names                             29
             Included File List                                29
                 Version Control                               30
             Excluded File List                                30
         Display/Print Manual                                  30
         Quit                                                  30
     Utilities                                                 31
         Create/Update VCM Path File                           31
         Create new VCM File                                   32
         Rollback VCM file                                     32
         Rebuilding Indices                                    32
         Initializing Databases                                32
         Purging Backup.$$$ files                              33
     Quit to DOS                                               34






                                     - Page 3 -







                                  TABLE OF CONTENTS


     Appendices                                                35
         Appendix A/ Generic Editor                            35
         Appendix A-1/ System Menu                             42
             Sysmenu edit                                      42
             Foxpro Calculator                                 42
             Foxpro Calendar                                   42
             Foxpro DOS Shell                                  43
             Print Mode                                        43
             Printer Eject                                     43
             Video Mode                                        43
         Appendix B/ Data Files                                44
             Backup/Restore Data files                         46
         Appendix C/ Error Handling                            47
             Verification                                      47
                 Bad Record Count                              47
             Disk Space                                        48
             Printer not Ready                                 48
             Multi-User Errors                                 49
             Syntax Error                                      49
         Appendix D/ Configuring Application                   50
             Foxpro Runtime Unit                               50
                 FOXR.EXE                                      50
                 FOXRW.EXE                                     51
             CONFIG.FP                                         51
                 COLOR SET                                     52
                 EMS                                           52
                 MEMLIMIT                                      52
                 PROGWORK                                      53
                 RESOURCE                                      53
                 TIME                                          54
             FOXPRO.INI                                        55
                 ADD                                           55
                 BORDER                                        56
                 DATA                                          57
                 FONTNAME                                      57
                 FONTSIZE                                      57
                 FONTSTYLE                                     57
                 HOST                                          58
                 INIT                                          58
                 LAST                                          58
                 MULT                                          58
                 PROG                                          59
                 RECALL                                        59
                 REFRESH                                       59
                 SYSMENU                                       60
                 TEMP                                          60
                 TERM                                          60
             FOXUSER.DBF                                       61
             FOXUSER2.DBF                                      61
             Printer Codes                                     62
             Record Filters                                    62
             Configuring Sideways                              62
     Glossary                                                  63
     Index                                                     66

                                     - Page 4 -







                                    Introduction


     The Version Control & Maintenance System is an application that allows
     either the client or the programmer to maintain their database of
     source code.  VCM is written in a dBASE IV compatible language called
     Foxpro.

     Before continuing, we should explain a couple of terms.  First, we
     will refer to the Version Control & Maintenance System as the VCM
     System.  Or simply as VCM.

     When we refer to a user's database of source code, we're talking about
     program files.  Every application has it's own set of program files,
     also known as source code.  A user's entire collection of
     applications, maintained by the VCM System, is a database of source
     code.

     We refer to a user identification as a "user-id".  Every user must be
     assigned a user-id.  A user-id defines the list of accessible file
     directories.

     When we refer to an "editor", it is a program module that allows us to
     add, delete, or change database records. The word "edit" means to
     update, maintain, or change a database record.

     When we refer to a "window", it is a section of the screen that is
     receiving output.  Windows may overlap each other on the screen.  They
     are characterized by a double line border and usually have some sort
     of title.

     A "record filter" determines the access allowed to a database.  Only
     those records, defined by a record filter, may be viewed, edited, or
     printed.  Record filters are created/selected using an "expression
     builder".

     Finally, when we say "DOS", we refer to the disk operating system.
     It's usually MS-DOS, but could be Microsoft windows, UNIX, or even the
     Macintosh OS.

     The first section of this manual will describe how to install the VCM
     System.  There are sections that explain the edit, print, system, and
     utility menus.  Appendices are included to describe the generic
     operations of editors, error handling, optimizing VCM, and
     establishing a backup procedure.













                                     - Page 5 -







                                    Introduction


                              Notation Conventions


     CAPITAL LETTERS

          Capital letters indicates a command.  During command entry, this
          text should be entered exactly as it appears.  Unless specified,
          any command may be in upper or lower-case letters.

     lower case

          Parameters to commands are usually typed in lower-case
          characters.

     Ellipsis "..."

          The ellipsis represent repetition of a previous item.

     Single Key "[ ]"

          The single key command is represented by the characters "[" and
          "]".

     Control keys

          Control keys are designated with a "[Ctrl]-" followed by the name
          of another key (for example: [Ctrl]-[S]).  To enter a control
          key, press [Ctrl] on your keyboard and, while holding it down,
          press the additional key.  On some Foxpro menus, control keys are
          designated with a "^" followed by the name of another key (for
          example: ^[End] for [Ctrl]-[End]).

     Carriage Return

          Depending on your keyboard, the same key may be represented by
          different descriptions.  For example, the carriage return may be
          represented as [Enter], [Return], or [Bent arrow symbol].  For
          the most part, this should not be a problem.  Make sure, however,
          that you understand the function of each key so that you
          understand how they appear in this manual.

     Alternate key

          On an IBM PC keyboard, alternate keys are designated with a
          "[Alt]-" followed by the name of another key (for example: [Alt]-
          [V]).  To enter a control key, press [Alt] on your keyboard and,
          while holding it down, press the additional key.

          On a Macintosh keyboard, [Alt] is produced by holding down both
          the [Ctrl] key and the [Option] key.  To produce [Alt]-[V], for
          example, you must press [Ctrl], [Option], and [V] at the same
          time.



                                     - Page 6 -







                                   System Startup



     For version control to proceed, two copies of the VCM System must be
     installed.  One on a remote machine, one on a host machine.  The host
     machine will contain the master copy of source code.  You would own
     the remote machine.  Normal operation would proceed as follows:


                                Client Overview


     From the remote machine, you would use PC-to-PC software to log onto
     the host machine.  You would run the host machine's VCM System and
     generate a file called REMOTE.ZIP.  This file will contain all source
     code, updated since the last time you logged onto the host machine.

     After exiting the host's VCM System, you would send REMOTE.ZIP to your
     remote machine.  Then you would log off the host machine.  Back on the
     remote machine, you would run the VCM System and retrieve REMOTE.ZIP.
     This process ensures you have to latest source code and can be
     repeated as often as desired.


     Note:  As a client, if you modify source code, be aware that any
     updates from the host will eliminate your changes.  Retrieving ZIP
     files, however, does create backup copies of source code.


                              Programmer Overview


     If your a programmer, and have the security clearance, you may also
     send your latest updates to the host machine.  On the remote machine,
     you would run the VCM System and generate a file called HOST.ZIP.
     This file will contain all source code, updated since the last time
     you ran the remote machine's VCM System.

     After exiting your VCM System, you would log into the host machine.
     You would send HOST.ZIP to the host.  Then, you would run the host
     machine's VCM System and retrieve HOST.ZIP.  This process can be
     repeated as often as desired.


     Note:  As a programmer, be aware that any updates from the host will
     override your changes.  Retrieving ZIP files, however, does create
     backup copies of source code.  It is the programmer's responsibility,
     therefore, to:  Receive the host's changes, reconcile the remote's
     changes, and return the updated source code to the host.








                                     - Page 7 -







                                   System Startup


                                 Host Start-up


     For normal operations, each VCM System must first be initialized.  But
     purposes of this session, the host system and the remote system will
     be one and the same.

     Your computer should be running and you should be at the DOS prompt
     (in your startup directory).  You should have already installed your
     VCM System and your Foxpro runtime unit.

     For start-up operations to begin, the system administrator on the host
     machine would first assign you a user identification number.  Only a
     user, with a valid user id, may run the host's VCM System.

     However, since this is the VERY first time you will be running this
     application (and only for purposes of testing), you may begin as if
     you were on a host machine.  At the DOS prompt, type:


          HOST TEMP


     and press [Enter].  "TEMP" will be your user id for this session.  All
     VCM database files are verified (see Appendix C).  You should see is
     the following startup screen:


     +---------------------------------------------------------------------+
                   Version Control & Maintenance, Version 03.00.00
                      (c) 1992 Dennis Allen, All rights reserved
     |                                                                     |
      --------------------- Data Path/File Names -----------------------
     |                                                                     |
               ZIP file Data Path        : C:\
     |                                                                     |
     |                                                                     |
     |---------------------------------------------------------------------|
               Press [ESC] to abort and return to main menu...
     +---------------------------------------------------------------------+


     This is the first of three screens that defines the default VCM
     settings.  They can be found in the system setup menu.  This screen
     defines the communication application directory.  This is where your
     ZIP files are sent and received.  Type the name of your PC-to-PC
     application directory.  If you don't have one yet, just press [Enter].

     The next screen is a browse list of all valid files.  Any file, not
     defined in this list, is ignored by the VCM System.  This list also
     defines version control.  For more information, see System Setup.
     Press [F10] to continue.



                                     - Page 8 -







                                   System Startup


     The next screen is also a browse list.  This list defines individual
     files to be excluded from the VCM system.  For more information, see
     System Setup.  You should already have a default list.  Press [F10] to
     continue.

     You will be prompted to confirm the user id "TEMP".  Press [Enter].
     Since "TEMP" is a new user-id, you will be asked if you wish to add
     your user-id.  Press [Y].  You will be prompted for a root directory.
     For our example, type "C:\VCM" and press [Enter].  This directory, and
     all sub-directories (with any file defined in the included file list),
     will be assigned to the user-id "TEMP".  You should then see the
     following screen:


     +---------------------------------------------------------------------+
                   Version Control & Maintenance, Version 03.00.00
                     (c) 1992 Dennis Allen, All rights reserved
                              Host User ID is TEMP
      -----------------------  M A I N    M E N U -----------------------
     |                                                                     |
                          1 - Retrieve HOST.ZIP File
                          2 - Create REMOTE.ZIP File
                          E - Create/Maintain Edit Files
                          P - Print Reports
                          C - Change User ID
                          S - System Setup (Query)
                          U - Utilities
                          M - Change Status (Single-User)
                          Q - Quit this program
     |                                                                     |
     |---------------------------------------------------------------------|
                               Make a selection:
     +---------------------------------------------------------------------+


     This is our main menu.  Option '1' deals with HOST.ZIP.  On a remote
     machine, you may create HOST.ZIP.  On a host machine, option '1'
     retrieves HOST.ZIP (if it exists in the communication directory).

     Option '2' deals with REMOTE.ZIP.  On a host machine, you may create
     REMOTE.ZIP.  On a remote machine, option '2' will retrieve REMOTE.ZIP
     (if it exists in the communication directory).

     Option 'E' allows you to create and maintain all Edit file.  Option
     'P' will print reports.  Option 'C' allows you to change the current
     user-id (without having to exit the VCM System).  Option 'S' allows
     you to change printer codes and system defaults.  Option 'U' contain
     miscellaneous options that allow the user to maintain VCM.  Option 'Q'
     will return you to the DOS prompt.

     By default, VCM runs in a single-user mode.  Option 'M' is available
     only in multi-user mode.  If you are running in a Multi-user
     environment, you will need to configure VCM to run Multi-user mode.
     Please refer to Appendix D for more information.

                                     - Page 9 -







                                   System Startup



     There are a couple of ways to select an option.  One way is to simply
     press the highlighted key, (example: press [S] for system setup).
     Another way is to press the up and down cursor keys to highlight the
     desired option.  Then, by pressing [Enter], the highlighted option is
     selected.

     Note:  If you have a mouse, you can move the mouse cursor to the
     desired option.  Pressing the left mouse button will then select the
     option.


                              Creating REMOTE.ZIP



     The next step is to create REMOTE.ZIP.  At the main menu, press [2].
     There will be a wait window.  Press any key to create REMOTE.ZIP (or
     [Esc] to abort).  Our REMOTE.ZIP will be created in the communication
     directory and will contain all the directories assigned to the user-id
     "TEMP".  When finished, press [Q] to quit to DOS.


                                Remote Start-up


     At this point, we would use our PC-to-PC package to send REMOTE.ZIP to
     the remote machine and logoff.  But for our session, assume we did
     that already.  Now, at the DOS prompt, type:


               REMOTE TEMP


     and press [Enter].  Normally, at this point, we would get a "User ID:
     TEMP not found.  Retrieve remote.zip file?" prompt and we would answer
     [Y].  But since "TEMP" already exists in our VCM System, we are given
     the main menu.  So press [2] to retrieve the REMOTE.ZIP.

     This is the first time we're using this user-id on a remote system.
     So we will get an error message "Missing VCM Paths.  Please update and
     try again.".  Don't panic.

     The VCM System has only four database files:  USER.DBF, VCMPATH.DBF,
     VCM.DBF, and VCMHIST.DBF.  USER.DBF stores a user identification
     number.  In a multi-user environment, you may access only one user id
     at a time.  VCMPATH.DBF stores all file paths assigned for the given
     user-id.  VCM.DBF stores all file path, names, dates, and times.
     VCMHIST.DBF simply stores a history of changes to VCM.DBF.

     VCMPATH.DBF not only contains the host's list of file directories, but
     the remote's corresponding list of directories.  In other words, the
     host can have a "C:\VCM" system that updates the remote's "D:\VCM"
     system.

                                     - Page 10 -







                                   System Startup



     We got an error message because we haven't yet defined the remote's
     corresponding directories.  So at the main menu, press [E].  You
     should see the following screen:


     +---------------------------------------------------------------------+
                   Version Control & Maintenance, Version 03.00.00
                     (c) 1992 Dennis Allen, All rights reserved
                              Remote User ID is TEMP
      ----------------------  E D I T    M E N U ------------------------
     |                                                                     |
                         1 - Edit VCM File
                         2 - Edit VCM History File
                         3 - Edit VCM Path File
     |                                                                     |
                         Q - Return to main menu
     |                                                                     |
     |---------------------------------------------------------------------|
                                  Your selection:
     +---------------------------------------------------------------------+


     This is the edit menu.  Here, all components of the VCM System can be
     maintained.  Option '1' will allow you to maintain VCM.DBF.  Option
     '2' will allow you to maintain VCMHIST.DBF.  Option '3' will allow you
     to maintain VCMPATH.DBF.  Option 'Q' will return you to the main menu.

     Before continuing, notice that the edit window is slightly smaller
     than the main menu window.  This is a built-in feature.  This feature
     allows the user to see how far he/she is into the program.  It is
     intended to give the user a sense of depth.


                               Updating VCM Paths


     Updating VCM Path records is simple.  At the edit menu, press [3].
     The following screen will appear:


     +---------------------------------------------------------------------+
                   Version Control & Maintenance, Version 03.00.00
                     (c) 1992 Dennis Allen, All rights reserved
                              Remote User ID is TEMP
      -------------------------- VCM Path File -------------------------
     |                                                                     |
          User ID: TEMP
     |                                                                     |
          File Path       : C:\VCM\          ZIP Allowed:   Y
     |                                                                     |
          Remote File Path:  :\VCM\          ZIP Allowed:   Y
     |                                                                     |
     +---------------------------------------------------------------------+

                                     - Page 11 -







                                   System Startup


     +---------------------------------------------------------------------+
             Toggle Index (File Path)    Toggle Order (Ascending)
             Add    Browse Delete Find   Goto   Help  Update   Quit
     +---------------------------------------------------------------------+


     This screen is typical of a generic editor used with Foxpro.  At the
     bottom of the screen are all the one-character options available to
     the user.

     Like the main menu, there are three ways of selecting a function.  By
     direct keystroke, by the cursor keys and [Enter], or by the mouse.
     Before continuing, we will briefly describe each function.

                                  Add Function

     Pressing [A] will allow you to add a record to the current database.
     The cursor will be positioned on the first field in the record.
     Whether adding or updating a record, there only a few keystrokes you
     need to know.

     You can move the cursor from field to field using the arrow keys.  For
     instance, the Right arrow, the Down arrow, and the Enter key, moves
     the cursor forward one field at a time.  The up arrow moves the cursor
     back one field.

     Note:  If you have a mouse, you also can move from field to field.
     Simply move the mouse cursor to the desired field and press the left
     mouse button.

     The [Home] key will move the cursor to the beginning of a field.  If
     it is already there, [Home] will move the cursor to the first field in
     the screen.  [End] will move the cursor to the end of the field.  If
     it is already there, [End] will move the cursor to the last field in
     the screen.

     If you need more information on any field, press [F1].  If there is
     help information, a help window will be displayed.  The help window
     will remain until you press either [Esc] or [F10].

     Note:  If you have a mouse, move the mouse cursor to the desired
     field.  Press the right mouse button, once to move to the field, and
     once for the help text.

     After you have entered your data, moving the cursor beyond the last
     input field on the screen tells the editor to accept the record.  You
     can either use the arrow keys to move the cursor, or press [F10].
     [Esc] will abort any updating, returning the screen to its original
     condition.






                                     - Page 12 -







                                   System Startup


                                Browse Function

     Pressing [B] will invoke the Foxpro browse function.  The browse
     function will display as many database records as will fit on one
     screen.  You use the arrow keys to move from record to record.
     Pressing [F10] will return you to the edit screen.  The browse
     function is explained in more detail in Appendix A.

                                Delete Function

     Pressing [D] will allow you to delete the currently displayed record.
     You will be prompted whether you are sure.  Pressing [Y] deletes the
     record from the database.

                                 Find Function

     Pressing [F] will invoke the find function.  This option is a quick
     way of finding a desired record.  Since the current database is
     indexed by file path, this option will prompt you for the host's file
     path.  Type the desired path and press [Enter].  If found, the desired
     record will be displayed.  You could then delete it, or update it.

                                 Goto Function

     Pressing [G] will create a pop-up menu.  This popup menu allows the
     user to display different records in the current database.  Press [F]
     for the first record in the database.  Press [L] for the last record.
     Press [N] for the next record.  Press [P] for the previous record.
     The goto window remains active until you press [Esc] or [Q] to quit.
     The goto function is explained in more detail in Appendix A.

                                 Help Function

     Pressing [H] will display a summary of commands used in the edit menu.
     Pressing any key after that returns you to the edit menu.

                             Toggle Index Function

     For a database with multiple indices, the toggle option will be
     displayed.  The toggle option allows the user to change what index
     will be used with the [F]ind option.  The current index is displayed
     in parenthesis.

     For example, if the current index is by host file path, pressing [T]
     will change the current index to the remote's file path.  Upon
     pressing [F], the user will be prompted for the remote's file path.
     Pressing [T], repeatedly, will eventually return you to the host's
     file path.

                             Toggle Order Function

     This option toggles the order of the current index.  The current order
     is displayed in parenthesis.


                                     - Page 13 -







                                   System Startup


     For example, if the current order is ascending, pressing [O] will
     toggle the order to descending.  If the current index is by last name,
     then 'ALPHA' will come after 'BETA'.  Pressing [O] again will change
     the current index back to ascending.

                                Update Function

     Pressing [U] allows you to update the currently displayed record.
     Like the add function, pressing [F10] will complete the update.
     Pressing [Esc] will abort the update.

                                 Quit Function

     Finally, pressing [Q] would return you the menu that invoked the
     editor.  For more information on the capabilities of this type of
     editor, see Appendix A.


                           Updating a VCM Path Record


     Now that you have an idea how the editor works, you can update the
     current record.  Press [U] at the option prompt.

     The "file path" field is the host's file path and can only be edited
     on the host.  The host "ZIP Allowed" field indicates whether the host
     may send source code and whether the remote may receive source code1.

     The next field specifies the remote's file path, corresponding to the
     host file path.  This field MUST be complete.  For our session, type
     the same path as the host's file path and press [Enter].

     The remote "ZIP Allowed" field indicates whether the remote may send
     source code to the host and whether the host may receive source code2.

     The current record should be complete.  Since we needed to update only
     one record, press [Q] to quit.  From the edit menu, press [Q] to quit
     to the main menu.  Now that we have completed the directory
     information, press [2] to receive REMOTE.ZIP.  This time, the process
     of receiving should be without error.

     Note:  If you still get a "PATH not found", go back to the VCM Path
     editor and check your records.  All remote paths MUST exist.






     ____________________
     1 Note:  This field may only be updated by the host (security
     clearance).
     2 Note:  This field may only be updated by the host (security
     clearance).

                                     - Page 14 -







                                   System Startup


                               Creating HOST.ZIP


     The next step is to send a HOST.ZIP to the host.  If you have a client
     system (only receiving files from the host), this will be the only
     time you need to send one.  Press [1] to create a HOST.ZIP.  When
     complete, press [Q] to quit to the DOS prompt.


                                  Host Restart


     At this point, we would use our PC-to-PC package to log onto the host
     machine and send our HOST.ZIP.  But for our session, assume we did
     that already.  Now, at the DOS prompt, type:


               HOST TEMP


     and press [Enter].  At the main menu, press [1] to receive the
     HOST.ZIP.  At this point, each VCM System has been initialized.
     However, no source code has been sent.


                               Normal Operations


     Now we're ready to begin normal operations.  If we were on a host
     machine, separate from the remote, we would again press [2] to create
     REMOTE.ZIP.  REMOTE.ZIP would now contain all the source code the
     remote computer needed.  We would send REMOTE.ZIP to the remote
     machine, logoff, and receive REMOTE.ZIP from the remote's VCM System.

     But our session's host and remote machines are one and the same.  The
     remote machine, therefore, needs no source code from the host.  So
     REMOTE.ZIP would not contain source code.

     Well, we've installed the source code database for our host and remote
     machines.  If you wish, experiment sending and receiving ZIP files.
     Or you may want to stay at the main menu for the next section in this
     manual.  We will be going over the VCM file editors.













                                     - Page 15 -







                               Maintaining VCM records


     From the main menu, press [E] for the edit menu.  You should see the
     following:


     +---------------------------------------------------------------------+
                   Version Control & Maintenance, Version 03.00.00
                     (c) 1992 Dennis Allen, All rights reserved
                              Host User ID is TEMP
      ----------------------  E D I T    M E N U ------------------------
     |                                                                     |
                         1 - Edit VCM File
                         2 - Edit VCM History File
                         3 - Edit VCM Path File
     |                                                                     |
                         Q - Return to main menu
     |                                                                     |
     |---------------------------------------------------------------------|
                                  Your selection:
     +---------------------------------------------------------------------+


     This is the edit menu.  Here, all components of the VCM System can be
     maintained.

     The VCM System has only four database files:  USER.DBF, VCMPATH.DBF,
     VCM.DBF, and VCMHIST.DBF.  The VCM System handles USER.DBF itself.
     VCMPATH.DBF stores file paths assignments.  VCM.DBF stores all file
     path, names, dates, and times.  VCMHIST.DBF simply stores a history of
     changes to VCM.DBF.

     Option '1' will allow you to maintain VCM.DBF.  Option '2' will allow
     you to maintain VCMHIST.DBF.  Option '3' will allow you to maintain
     VCMPATH.DBF.  Option 'Q' will return you to the main menu.


                                   ZIP Files


     When you create either REMOTE.ZIP or a HOST.ZIP, the VCM System
     searches through all the directories in VCMPATH.DBF.  All files found
     are listed in VCM.DBF.  Any file additions, deletions, or updates to
     VCM.DBF are logged into VCMHIST.DBF.  When you send/receive a ZIP
     file, a copy of VCM.DBF, VCMHIST.DBF, and VCMPATH.DBF are included.


     We have already looked at the VCMPATH.DBF file editor.  Now let's take
     a look at the VCM.DBF editor.  At the edit menu, press [1].  You
     should see the following screen:







                                     - Page 16 -







                               Maintaining VCM records


     +---------------------------------------------------------------------+
                   Version Control & Maintenance, Version 03.00.00
                     (c) 1992 Dennis Allen, All rights reserved
                              Host User ID is TEMP
      ------------------------ Edit VCM File ---------------------------
          User ID: TEMP
     |                                                                     |
          File Path       : C:\VCM\
     |                                                                     |
          Remote File Path: C:\VCM\
     |                                                                     |
          File Name       : VCM.PRG                    Actual Host
          Date: 07/16/96                                07/16/96
          Time: 16:19:06                                16:19:06
          Size:      44696 bytes                        44696 bytes
     |                                                                     |
          Type: H
     |---------------------------------------------------------------------|
                         Modify Host File
             Toggle Index (File Path)    Toggle Order (Ascending)
             Add    Browse Delete Find   Goto   Help  Update   Quit
     +---------------------------------------------------------------------+


     The edit functions are exactly the same as in the VCM Path editor.
     There is one additional function, allowing a system administrator to
     actually modify the current file.

     You have the "user-id" and host "file path" fields, which comes from
     the host.  The "remote file path" field comes from the associated host
     "file path" in VCMPATH.DBF.  The "user-id", host "file path", and
     "file name" determine a unique record.  The "date", "time", and "size"
     fields determine if a file has been changed.  To the right of these
     fields are displayed the file's actual date, time, and size.

     The record "type" field indicates what action took place, the last
     time you created or received a ZIP.  The possible values are:


          F    -    File.  No action.
          D    -    Deleted.  File was removed from other VCM System.
          H    -    History.  File that has been updated.
          O    -    Out of Sync.  File is overwritten from host.
          U    -    Undefined.  File cannot be unzipped.


     If a file record is type "F" or "H", no problem.  Type "F" indicates
     nothing has occurred with this file, lately.  Type "H" indicates that
     the file has been updated, but not on both VCM Systems.

     If a file record is type "D", the file was deleted from the other VCM
     System.  If you are on the remote, the file was deleted on host.
     While receiving a ZIP from the host, you would be prompted whether you
     wish to physically remove your copy.

                                     - Page 17 -







                               Maintaining VCM records



     If a file record is type "O", you received a file from host.  If a
     file record is type "U", the file could not be unzipped on other
     machine (usually the host).  Let me explain.

     The VCM System allows you to modify a file on the remote AND host at
     the same time.  Nothing prevents that.  However, the HOST machine has
     priority.

     Example:  Say that you and the host modify the same file, since the
     last time you were on the host.  If you try to send this file to the
     host, you will get a file type "U" and the file will not be unzipped.
     When you receive a ZIP from the host, your file will be overwritten
     with the host's file (file type "O").


     Note:  The VCM System does create backup copies of source code.  These
     files will have a "$" file extension.  If you ever receive an out-of-
     sync file, simply use the backup copy to add your changes to the
     host's file.  Then send a new REMOTE.ZIP to the host.


     Well, that's the VCM.DBF file layout.  The edit functions are exactly
     the same as in the VCM Path editor.  The VCMHIST.DBF file layout is
     exactly the same.  Experiment, if you wish, in adding, updating, or
     browsing.  When finished, press [Q] to quit to the edit menu.


     Just remember:  Unless explicitly stated, a "file path" refers to the
     host's file path.


                                      Quit


     Well, that's all you need to know about the edit menu.  Later, you can
     experiment with finding, deleting, and updating records.  For now,
     simply press [Q] to return to the main menu.

















                                     - Page 18 -







                                   Print VCM Files


     In the first half of this manual we learned how to create the VCM
     database.  Now we are going to learn how to print record in the VCM
     system.

     From the previous examples, you should now be at the main menu.  We
     will be printing a record, so make sure your printer is connected and
     on-line.  If not, you may wish to skip this section.  If your printer
     is ready, press [P].  You should see the following screen:


     +---------------------------------------------------------------------+
                   Version Control & Maintenance, Version 03.00.00
                     (c) 1992 Dennis Allen, All rights reserved
     |                                                                     |
      ------------------------- P R I N T    M E N U --------------------
     |                                                                     |
           1 - Print VCM         Edit List    A - Check Translated Code
           2 - Print VCM History Edit List    B - Check Parameter  Code
           3 - Print VCM Path    Edit List    C - Compare Host and Remote
     |                                                                     |
                          Q - Return to main menu
     |                                                                     |
     |                                                                     |
     |---------------------------------------------------------------------|
                                  Your selection:
     +---------------------------------------------------------------------+


     The menu is simple and self-explanatory.  Option '1' allows you to
     print an edit list of VCM.DBF.  Option '2' will print an edit list of
     VCMHIST.DBF.  Option '3' will print an edit list of VCMPATH.DBF.

     Option 'A' allows you to verify translated files against your version
     control files.  Option 'B' will show you which files have been updated
     recently.  If the host and remote files are on the same system, option
     'C' allows you to perform direct file compares.

     Option 'Q' will return you to the main menu.

     Note:  Options 'A', 'B', & 'C' assume VCM.DBF is current.  If you
     haven't created a ZIP file lately, use option '2' of the utility menu.


                             Printing VCM Edit List


     Option '1' produces an edit list of VCM.DBF.  Option '2' produces an
     edit list of VCMHIST.DBF.  Since each report provides the same prompts
     and produces the same type of output, we will skip describing the
     option '1' report.





                                     - Page 19 -







                                   Print VCM Files


                         Printing VCM History Edit List


     Option '2', of the print menu, introduces the concept of the option
     grid.  The VCM History edit list will be your most often used report.
     This report will tell you what events occurred when a ZIP was sent or
     received.  At the print menu, press [2].  You should see the following
     screen:

     +---------------------------------------------------------------------+
                   Version Control & Maintenance, Version 03.00.00
                   (c) 1992 Dennis Allen, All rights reserved
     |                                                                     |
      ------------------- Print VCM History File ------------------------
     |                                                                     |
               File Path       :
     |                                                                     |
     |                                                                     |
               File Name       :
     |                                                                     |
               Date:   /  /
               Time:   :  :
               Size:
     |                                                                     |
               Type:                    Compare to actual?
     |                                                                     |
               Index File :
               Index Order:
     |---------------------------------------------------------------------|
                 Print   Screen    Help   Update    Quit
     +---------------------------------------------------------------------+


     You are given an option grid.  The option grid will look like the VCM
     edit window.  The option grid prompts will determine what records will
     be printed and in what order.  For example, specifying "H" for type
     will print a listing of all files that were extracted from the last
     ZIP.

     Most fields provide this wild-carding technique.  The exception is the
     date field.  An file date of "01/01/91", for example, will print only
     those files have been updated since January 1, 1991.

     The option grid includes a prompt to compare records to actual files.
     If marked "Y", only records that differ with the actual file (date,
     time, or size) will be listed.

     From this option grid, you are also allowed to select the index file
     and index order.  These fields are the push button equivalent to the
     toggle index/toggle order found in the VCM history editor.





                                     - Page 20 -







                                   Print VCM Files


     Press [F10] to complete the option grid.  You will be given a menu of
     choices, depending on the report.  You can press [U] to update the
     option grid.  You can press [H] for help, or press [Q] to quit to the
     print menu.

     Pressing [S] for screen mode, or [P] for print mode, will start
     creating a print file.  During this operation, you can abort by
     pressing [Esc].

     If you pressed [S], you will see the report displayed upon the screen.
     Press [Pgup] or [Pgdn] to view the report.  Press [Esc] or [F10] to
     return to the option grid.

     Pressing [P] will copy the report to the printer.  When you are
     finished, press [Q] to return to the print menu.

     Note:  If you need to adjust the printer device or printer controls,
     use option S of the main menu.  See System setup.


                          Printing VCM Path Edit List


     Option '3' of the print menu will offer an option grid, similar to the
     VCM Path editor.  Like the previous two reports, press [F10] completes
     the option grid.  From there, you can press [S] to view the report,
     [P] to print the report, or [Q] to quit and return to the print menu.


                             Check Translated Code


     Upon pressing [A], at the print menu, all version control files (see
     system setup) are check against translated files.  The first comment
     line, beginning with "*" and containing "Version" will be compared.  A
     report will be displayed, listing only files with comment lines that
     do not match.  You can then determine if your translated code is up-
     to-date with your version control code.

     Use [PgUp] or [PgDn] to scroll through this report.  Press [Alt]-[P]
     to print this report.  Press [Esc] to return to the print menu.














                                     - Page 21 -







                                   Print VCM Files


                              Check Parameter Code


     Upon pressing [B], at the print menu, all version control files (see
     system setup) are checked.  You will be prompted for the parameter
     file name and the parameter date.  A report will be displayed.  In
     this report, the first comment line, beginning with "*", containing
     the specified parameter name, and a date greater than or equal to the
     parameter date, will be displayed.  You can then determine which files
     you recently worked on.

     Use [PgUp] or [PgDn] to scroll through this report.  Press [Alt]-[P]
     to print this report.  Press [Esc] to return to the print menu.


                             Compare Host to Remote


     On my computer, I have a modified master set of a popular accounting
     system.  This master set contains version control source code, as well
     as the translated executables.  I also keep a copy of the original
     master set.  Periodically, I receive updates to the original master
     set.  Updates which must be brought into the modified master set.

     This report will help you accomplish this task.  First, you need to
     set up your original master set as "host".  Then, define all your
     remote file paths to your modified master set.  Since both host and
     remote systems are on your computer, you do not need to create or
     retrieve "ZIP" files.

     Now as a "host", select option "C" of the report menu.  You should now
     see the following screen:

     +---------------------------------------------------------------------+
                   Version Control & Maintenance, Version 03.00.00
                   (c) 1992 Dennis Allen, All rights reserved
     |                                                                     |
      ------------------- Compare Host to Remote ------------------------
     |                                                                     |
               File Path       :
     |                                                                     |
     |                                                                     |
               File Name       :
     |                                                                     |
               Date:   /  /
               Time:   :  :
               Size:
     |                                                                     |
               Type:               Create CSV & FC compare files?
     |                                                                     |
               Index File :
               Index Order:
     +---------------------------------------------------------------------+


                                     - Page 22 -







                                   Print VCM Files


     +---------------------------------------------------------------------+
                 Print   Screen    Help   Update    Quit
     +---------------------------------------------------------------------+


     Like the option grid in the VCM edit list, this grid allows you to
     select records in VCM.DBF.  The "file path" refers to the host file
     path.

                                File Comparison

     There is an additional prompt to create *.CSV & *.FC files.  Very
     powerful.  If two files don't match, this prompt will perform a file
     compare using the DOS utility FC.EXE.  For example, we could run FC to
     compare the host file "C:\VCM\VCM.PRG" to the remote file
     "D:\VCM\VCM.PRG".  The resulting output file "D:\VCM\VCM.FC" will be
     created.

     If the included list (see system setup) contains Foxpro *.DBF, *.FRX,
     *.MNX, or *.SCX files, this option will create an associated comma
     delimited *.CSV text file.  For example, the host file
     "C:\VCM\VCM.DBF" would generate "C:\VCM\VCM.CSV".  The remote file
     "D:\VCM\VCM.DBF" would generate "D:\VCM\VCM.CSV".  FC.EXE would then
     compare these two VCM.CSV files, generating the output file
     "D:\VCM\VCM.FC".

     Press [F10] completes the option grid.  From there, you can press [S]
     to view the report, or [P] to print the report.  When you select
     either [S] or [P], you will get a listing of all host files that are
     different (date, time, and size) from the remote files.  If "FC" files
     were created, their size will also be listed.

     Press [Q] to quit and return to the print menu.


                                      Quit


     Try out the different reports.  When you have experimented enough,
     press [Q] at the print menu to return to the main menu.















                                     - Page 23 -







                                    System Setup


     Option 'S' of the main menu offers several facilities.  Among them,
     the ability to change printer control codes.  Upon pressing [S] at the
     main menu, you should see the following:


     +---------------------------------------------------------------------+
                   Version Control & Maintenance, Version 03.00.00
                      (c) 1992 Dennis Allen, All rights reserved
     |                                                                     |
      -------------------  S Y S T E M   S E T U P  ---------------------
     |                                                                     |
                          1 - Edit Expression Builder
                          2 - Edit Printer Control Codes
                          3 - Change Color Set
                          4 - Problems & Suggestions
                          5 - All about...
                          6 - Edit Data Path/File Names
     |                                                                     |
                          M - Display/Print Manual
     |                                                                     |
                          Q - Quit this Menu
     |                                                                     |
     |---------------------------------------------------------------------|
                                Your selection:
     +---------------------------------------------------------------------+


     Option '1' will invoke the expression builder.  The expression builder
     creates a record filter.  A record filter defines those records that
     can be viewed, edited, and printed.

     Option '2' allows you to change printer control codes.

     Option '3' will allow you to change the current color set.  If you
     don't like the colors used by VCM, this option lets you change them.

     Option '4' will allow you to leave a message to the application
     author.  Messages can point out a problem or can offer a suggestion.

     Option '5' will display status information about this application.
     What version of Foxpro is running and about much memory is available.

     Option '6' allows you to define the VCM System setup values.  These
     include the communication directory, the included file list, and the
     excluded file list.

     Option 'M' allows you to display and/or print the user manual.  Option
     'Q' returns you to the main menu.







                                     - Page 24 -







                                    System Setup


                               Expression Builder


     The expression builder allows you to select a record filter from a
     list of record filters.  A record filter defines those records in a
     database that can be viewed, edited, or printed.  The record filter is
     in effect only while your application is running.  Filters can be
     redefined as often as desired.

     At the system setup menu, press [1].  Upon entry, you are given a list
     of existing record filters.  Chose an existing filter.  For example,
     move the cursor to the filter named "History".  Press [Enter].  The
     filter "History" is now active and will allow you to view only VCM.DBF
     and VCMHIST.DBF records with type "H".

     You also might want to create a record filter.  At the system setup
     menu, press [1].  Press [F10] for the menu and press "N" to create an
     expression.  Enter "Deleted" for the name of your expression.  You
     will be given a choice of the custom expression builder, or the Foxpro
     expression builder.  Unless you know how to use the Foxpro expression
     builder, select the custom builder.

     You will be given a popup list of available field names.  Select the
     field "Type".  The next popup will display the action that can be
     taken on "Type".  Select the popup "Contains".  Now you will be
     prompted for a character string.  Type "D" and press [Enter].

     The record filter is displayed.  You may add, delete, or edit phrases
     in the expression.  But just press [F10] to accept the current one.

     That's all there is to it!  You've created a filter that views only
     records of deleted files.  Press [Enter] to select the filter.  You
     will be returned to the system setup menu.  If you don't want to use
     this filter, simply return to the expression builder and press [Esc]
     to abort.




















                                     - Page 25 -







                                    System Setup


                             Printer Control Codes


     At the setup menu, press [2].  The following screen will be displayed:


     +---------------------------------------------------------------------+
                   Version Control & Maintenance, Version 03.00.00
                     (c) 1992 Dennis Allen, All rights reserved
     |                                                                     |
      --------------------- S Y S T E M   S E T U P ---------------------
     |                                                                     |
                    Printer Name         : Default
                    Printer Device       : PRN
                    Printer Default      : CHR(27)+"@"
                    Printer 10 cpi       :
                    Printer 12 cpi       :
                    Printer Condense On  :
                    Printer Bold      On :
                    Printer Bold      Off:
                    Printer Underline On :
                    Printer Underline Off:
     |                                                                     |
                    Number of Straight Lines/Page:
                    Number of Sideways Lines/Page:
     |                                                                     |
                    Print in Draft mode?
     |---------------------------------------------------------------------|
              Press [ESC] to abort and return to main menu...
     +---------------------------------------------------------------------+

                                  Printer Name


     The printer name is simply identifies the current configuration.  If
     the database P_CODES.DBF is available, you may press [F1] for a list
     of all available printers.  A selection changes all printer codes to
     the selected printer.  Press [F10] to complete the screen.

                                 Printer Device

     The printer device defines where output is to be sent.  Typically, you
     would use LPT1 or LPT2.  In the Multi-user environment, this option
     also allows you to define the network spooler.











                                     - Page 26 -







                                    System Setup


                                 Printer Codes

     If you have an 80 column printer, define the control codes required by
     your printer to invoke compressed printing.  These control codes are
     sometimes referred to as 16.7 or 17 characters per inch.  Also define
     the control codes required to cancel condensed printing.  These
     control codes are sometimes referred to as the default.  VCM will use
     these codes for reports normally requiring a 132 column printer.
     Printer control codes are specified with dBASE expressions such as:

     CHR(27) + CHR(64)

     or:


     CHR(27) + '@'

     In general, most printer manuals give printer control strings as BASIC
     programming statements using the BASIC function CHR$().  The dBASE
     CHR() function is identical, so simply removing the "$" sign from the
     examples in your printer manual should do the job.

     Note:  If you press [F1], you will see a browse popup of available
     printers.  Simply select your printer and press [Enter].  All printer
     codes will be converted to the selected printer.

                            Straight lines per page

     To this day, there are some printers that do not accept form feeds.
     So rather than asking for form feed code, VCM asks for the number of
     lines per page.  Most printers use 66 lines.  Laser printers usually
     need 66 lines, though some may need 57 lines.

                                    Sideways

     It is sometimes necessary to print large reports using a sideways
     print utility.  So in case it is ever needed, the system setup prompts
     for the number of lines to print sideways.  For an 80 column printer,
     use 53 lines. For a 132 column printer, use 90 lines.

                                   Draft mode

     A report option grid creates a report file.  From the option grid,
     there are two ways to print this file:  Draft mode and non-draft mode.
     In draft mode, the report file is copied directly to the print device.
     Under MS-DOS Windows, draft mode bypasses the print spooler.  In non-
     draft mode, the report file is still copied to the print device, but
     through any and all print spoolers.

     Non-draft mode is only needed when you want the print spooler to
     control font and font pitch.  In that case, set all printer codes to
     empty via double quotes ("").  Otherwise, the printer codes will show
     up on your report.


                                     - Page 27 -







                                    System Setup



                                Change Color Set


     A Foxpro color set defines all color attributes used by this
     application.  Upon pressing [3] at the system setup, a popup menu will
     display all the different color sets available.  These color sets
     reside within the Foxpro resource file (FOXUSER.DBF).  Use the cursor
     keys to highlight the desired color set.  Then, select by pressing
     [Enter].

                             Customizing Color Sets


     A new feature has been added to the color selector.  The user now has
     the ability to customize colors.  Once a color has been selected, the
     color selector will search for a second Foxpro resource file
     (FOXUSER2.DBF).  In this file, color sets are stored in ASCII text
     format.

     If you are a system administrator, you will be prompted whether to
     edit the ASCII text of your selected color set.  The text layout is
     simple.  Twelve lines for the twelve color schemes used by this
     application.  Each line contain ten color pairs.  A color pair
     "W*/B+", for example, would denote a white foreground, blue background
     ("*" denotes blinking and "+" denotes intensity).  For a description
     of color pairs used within a scheme, check the color picker portion of
     the Foxpro manual.

     Experiment with different color sets.  Note that the top of the screen
     may not change color until you exit and reenter the application.  Be
     warned, however.  The color set becomes permanent until the next time
     you select a different color.

     Note:  The second Foxpro resource file can only be created and edited
     by the system administrator.


                             Problems & Suggestions


     Upon pressing [4], you will be presented with a memo window.  Type any
     message you wish to leave the application programmer.  Press [F10] to
     complete the message, or [Esc] to abort.  Your message will be placed
     in the Foxpro error file (FOXERR.DBF).

     If you have already created messages, you may wish to modify them.  A
     browse, indicating the date and time of each message, will be
     displayed.  Select the desired message record.  Then, press [Ctrl]-
     [Pgdn] to expand the message window.





                                     - Page 28 -







                                    System Setup


                                  All About...


     Option '5', of the system menu, will display status information about
     this application.  What version of Foxpro is running, about much
     memory is available, and the different kinds of application modes
     (Multi-user, debug, system administration).  This option will also
     tell you how the various data paths are defined.


                           Edit Data Path/File Names



     Upon pressing '6', at the system menu, you will be presented with the
     following screen:


     +---------------------------------------------------------------------+
                   Version Control & Maintenance, Version 03.00.00
                      (c) 1992 Dennis Allen, All rights reserved
     |                                                                     |
      --------------------- Data Path/File Names -----------------------
     |                                                                     |
               ZIP file Data Path        : C:\
     |                                                                     |
     |---------------------------------------------------------------------|
               Press [ESC] to abort and return to main menu...
     +---------------------------------------------------------------------+


     This is the first of three screens that defines the default VCM
     settings.  This screen defines the communication application
     directory.  This is where your ZIP files are sent and received.  Type
     the name of your PC-to-PC application directory.  If you don't have
     one yet, just press [Enter].


                               Included File List

     The next screen is a browse list of all valid files.  Any file, not
     defined in this list, is ignored by the VCM System.

     This list contains only two columns.  The first column defines the
     valid file names.  Wildcarding is permitted in this column.  The
     second column defines version control, which will be explained later.
     Wildcarding is not permitted in this column.

     You can press [PgUp] or [PgDn] to browse the list, [Ctrl]-[N] to add
     an item to the list, or [Ctrl]-[T] to delete an item from the list.
     You can press [F10] to save, or [Esc] to abort.




                                     - Page 29 -







                                    System Setup


                                Version Control

     Our own in-house staff uses a program called dVERSION.  dVERSION takes
     conditional source code and translate it into executable code.
     Conditional code is stored in a sub-directory from executable code.

     Example:  A program called "DP.VER" may contain conditional code.
     dVERSION would translate "DP.VER" into "DP.PRG", an executable
     program.  "DP.VER" would be stored in "\DP\VER\".  "DP.PRG" would be
     stored in "\DP\".

     If you look at the browse list, you will see a line [*.PRG] [VER].
     When the VCM System finds a program, such as "DP.PRG", it checks any
     sub-directories for a "DP.VER".  If found, the VCM System will ignore
     the file "DP.PRG".  In this way, the VCM System doesn't have to send
     duplicate and unnecessary files.  Press [F10] to continue.


     Note:  If you don't want to use version control, simply leave the
     version control column empty.  If you do use version control, remember
     to also define your version control files as part of the regular
     include list.  Otherwise, the VCM system will ignore them.


                               Excluded File List

     The next setup screen is also a browse list.  This list defines
     individual files to be excluded from the VCM system.  Because it works
     with the included file list, no wildcarding is permitted.  Example:
     You can include all "SYSD*.DBF" files, yet exclude the file
     "SYSDATA.DBF".

     For our example, press [F10].  You will be returned to the system
     menu.


                              Display/Print Manual



     Option 'M', of the system menu, will display the user manual.  You may
     use [PgUp] or [PgDn] to view various pages.  You may print the entire
     user manual by pressing [Alt]-P].  Press [Esc] to return to the system
     setup menu.


                                      Quit


     Before leaving the system setup menu, a reminder.  Record filters
     remain in effect only for the duration of the application.  Color sets
     and printer control codes, on the other hand, are permanent.  When you
     have experimented enough, press [Q] at the system setup menu to return
     to the main menu.

                                     - Page 30 -







                                      Utilities


     Option 'U' of the main menu provides the miscellaneous options needed
     to maintain the VCM system.  Upon pressing [U] at the main menu, you
     should see the following:


     +---------------------------------------------------------------------+
                   Version Control & Maintenance, Version 03.00.00
                      (c) 1992 Dennis Allen, All rights reserved
     |                                                                     |
      -------------------  U T I L I T Y    M E N U ---------------------
     |                                                                     |
                          1 - Create/Update VCMPATH file
                          2 - Create new VCM file
                          3 - RollBack   VCM file
     |                                                                     |
                          A - Rebuild indices
                          B - Initialize Databases
                          C - Purge Backup.$$$ files
     |                                                                     |
                          Q - Quit this Menu
     |                                                                     |
     |---------------------------------------------------------------------|
                                Your selection:
     +---------------------------------------------------------------------+


     Option '1' will create a new set of file directories.  Option '2' will
     create a new set of VCM file records, without actually creating a new
     ZIP file.  Option '3' allows you to rollback what was done in option
     '2'.

     Option 'A' reconstructs all system indices in the event of a crash or
     other strange system behavior.  Option 'A' also removes deleted
     records, thereby reclaiming disk space.

     Option 'B' will allow you to remove the current user from any or all
     database files in the VCM System.  Option 'C' will allow you to remove
     VCM System backup files.  Option 'Q' will return you to the main menu.

     Note:  Option '1' is only available on the host.  Options '1', 'B',
     and 'C' are only available to the system administrator.  See Appendix
     D.


                          Create/Update VCM Path File


     When you create a new user-id, a set of file directories are assigned
     to that user-id.  Option '1' allows you to either assign a new set of
     file directories, or append to your existing set, to the current user-
     id.




                                     - Page 31 -







                                      Utilities


     Upon pressing [1], at the utility menu, you will be prompted for the
     root directory.  You are then prompted whether you wish to append to
     the existing directory list.  Answering 'no' will remove the existing
     directory list.  The specified directory, and all sub-directories
     (with any file defined in the included file list), will then be
     assigned to the current user-id.  You will be returned to the utility
     menu.


                              Create new VCM File


     When you create a ZIP file, either on the host or on the remote, a new
     set of records are created in VCM.DBF.  Any changes in VCM.DBF are
     recorded in VCMHIST.DBF.  Option '2' does the very same procedure.
     Actually, it IS the same procedure.  However, no ZIP file is created.


                               Rollback VCM File


     Let's say, for example, you created a REMOTE.ZIP and tried to send it
     to the host.  In the process your computer locks up and trashed the
     REMOTE.ZIP.  In such an event, use option '3' of the utility menu.

     Option '3' simply moves the records, found in VCMHIST.DBF, to VCM.DBF.
     In effect, this option returns the state of your VCM System to where
     it was before you sent the ZIP file.


                               Rebuilding Indices


     Option 'A' of the utility menu will reconstruct all system indices in
     the event of a crash or other strange system behavior.  You will be
     prompted whether to continue.  Upon pressing [Y], all indices will be
     rebuilt.  Option 'A' also removes deleted records, thereby reclaiming
     disk space.  You will then be returned to the utility menu.


                             Initializing Databases


     Option 'B' of the utility menu will allow you to "remove" the current
     user from any or all database files in the VCM System.  You probably
     will want to use this option after completing the sample entries and
     exercises in this manual, so you can begin fresh with "real" data.

     Upon press [B] at the utility menu, you will be prompted whether to
     reset each database file, one at a time.  You will then be returned to
     the utility menu.




                                     - Page 32 -







                                      Utilities


                             Purge Backup.$$$ files


     Whenever source code is received, the VCM System will make backup
     copies of existing files.  Example:  The VCM System would create
     "DP.PR$" as a backup of "DP.PRG".

     Option 'C', of the utility menu, simply deletes backup files.  Any
     file, with a file extension "$", are removed from any directory
     assigned to the current user-id.

     Well, that's it for the utility menu.  When you have experimented
     enough, press [Q] at the utility menu to return to the main menu.










































                                     - Page 33 -







                                     Quit to DOS


     Once you have returned to the main menu, press [Q] to return to the
     DOS ready.  It is VERY important that you do not leave the VCM System
     without returning to DOS.  NEVER turn off the machine while in the VCM
     System.  Doing so may result in file corruption and lots of headaches
     to us developers.

     Well, you have a sample user "TEMP" to experiment on the VCM system.
     The next step is to become a system administrator on the host system.
     As a system administrator, you will be able to remove the user "TEMP",
     or add new user(s).  If you have to, reinstall the VCM system on the
     host.

     This concludes the system overview.  If you wish to know more about
     any of the VCM editors in the VCM System, see Appendix A.  If you wish
     to know about the file layouts, see Appendix B.  If you ever see the
     infamous error message "Ignore, Retry, Suspend, or Quit", see Appendix
     C.  If you wish to install the multi-user mode, see Appendix D.






































                                     - Page 34 -







                                     Appendix A


     This section describes all characteristics, in detail, of the generic
     editor used in this type of Foxpro application.  While this editor may
     be customized for many applications, all share common functions.
     Thus, to learn one version is to know another version.

     This type of Foxpro application usually has an edit menu.  This menu
     allows the user to invoke one or more editors.  The following is an
     example of the edit menu used in the dMAIL4 System:


     +---------------------------------------------------------------------+
                         Mailing List, Version 03.05.00
                   (c) 1987 Dennis Allen, All rights reserved
     |                                                                     |
      ----------------------  E D I T    M E N U ------------------------
     |                                                                     |
                         1 - Create/Edit Mailing List
                         2 - Create/Edit State IDs
     |                                                                     |
                         Q - Return to main menu
     |                                                                     |
     |---------------------------------------------------------------------|
                                  Your selection:
     +---------------------------------------------------------------------+


     In this edit menu, the user has the option to use two editors.  Each
     editor allows the user to maintain separate, but related, databases in
     the dMAIL4 System.  While we really don't need to go any further, but
     it is good to know where most editors are invoked.

     Once a generic editor is invoked, its window will be displayed.  The
     window consists of a window title, field descriptions, and all fields
     of the database record that happens to be current.  A menu window is
     also displayed.  The menu window contains all the one-character
     options available to the user.  The following is a sample screen of
     the mailing list editor used in the dMAIL4 System:


















                                     - Page 35 -







                                     Appendix A


     +---------------------------------------------------------------------+
                           Mailing List, Version 03.05.00
                       (c) 1987 Dennis Allen, All rights reserved
     |                                                                     |
      --------------------------- Mailing List --------------------------
      User ID:
      First Name:                       Last:
                 Billing                Shipping
      Address 1 :
      Address 2 :
      City/State:
      Zip Code  :
      Sex:          Status:             Head of HouseHold:
      Home: (  )    -                   Birth:
      Work: (  )    -                   Wedding:
      Soc.Sec. #:   -  -                Active Date:
           [ ] MS-DOS    +------------ Message Memo -------------+
           [ ] CP/M      |                                       |
           [ ] TRSDOS    |                                       |
                         +---------------------------------------+
     |---------------------------------------------------------------------|
             Toggle Index (Last Name)    Toggle Order (Ascending)
             Add    Browse Delete Find   Goto   Help  Update   Quit
     +---------------------------------------------------------------------+


     All editors have the same basic functions.  Before continuing, we will
     describe each function in detail.

                                  Add Function

     Pressing [A] will allow you to add a record to the current database.
     The cursor will be positioned on the first field in the record.  Now
     whether adding or updating a record, there only a few keystrokes you
     need to know.

     You can move the cursor from field to field using the arrow keys.  For
     instance, the Right arrow, the Down arrow, and the [Enter] key, moves
     the cursor forward one field at a time.  The left arrow and up arrow
     will move the cursor back one field.

     Note:  If you have a mouse, you also can move from field to field.
     Simply move the mouse cursor to the desired field and press the left
     mouse button.

     The [Home] key will move the cursor to the beginning of a field.  If
     the cursor is already there, [Home] will move the cursor to the first
     field in the screen.  The [End] key will move the cursor to the end of
     the field.  If the cursor is already there, [End] will move the cursor
     to the last field in the screen.

     If you need more information on any field, press [F1].  If there is
     help information, a help window will be displayed.  The help window
     will remain until you press either [Esc] or [F10].

                                     - Page 36 -







                                     Appendix A



     Pressing [Ctrl]-[Home] will repeat the last text that was displayed in
     the current field.  This function provides a convenient means of
     adding many records with similar field descriptions.

     Once you have entered your data, moving the cursor beyond the last
     field on the screen tells the editor to accept the record.  Pressing
     [F10] also will tell the editor to accept the record.  You would then
     be prompted to add another record.  The [Esc] key will abort the add
     function, returning the screen to its original condition.

                                Browse Function

     Pressing [B] will invoke the Foxpro browse function.  The browse
     function will display as many database records as will fit in one
     window.  You can use the left arrow, right arrow, [Tab], and [Shift]-
     [Tab] keys to move the cursor from field to field.  You can move from
     record to record with the up and down arrow keys.  You use the page
     up/down keys to display the next/previous window of records in the
     current database.

     If you have a mouse, you also can use the characters located on the
     right side of the window.  Place the mouse cursor on the up/down arrow
     characters and press the left button to move one record at a time.
     The diamond character show where you're located in relation to the
     rest of the database.  Place the mouse cursor on the diamond and press
     the left button.  Dragging the diamond will re-position you in the
     database.

     Mouse Note:  After you found the record you want, place the mouse
     cursor on the record and press the left button.  Otherwise, the first
     time you try to update a record will put you back to the last record
     displayed before using the mouse.

     If there are more fields than can be displayed in one window, pressing
     [TAB] will scroll to the next field.  Pressing [Shift]-[TAB] will
     scroll back one field.

     If you have a mouse, you also may use the characters located across
     the bottom of the window.  Place the mouse cursor on the left/right
     arrow characters and press the left button to move one field at a
     time.  The diamond character show where you're located in relation to
     the rest of the database.  Place the mouse cursor on the diamond and
     press the left button.  Dragging the diamond will re-position the
     fields displayed in the database.

     Mouse Note:  After you found the field you want, place the mouse
     cursor on the field and press the left button.  Otherwise, the first
     time you try to update a field will put you back to the last field
     displayed before using the mouse.





                                     - Page 37 -







                                     Appendix A


     In the browse function you may edit any field as desired.  Press
     [Ctrl]-[N] to add a record from the browse.  Press [Ctrl]-[T] to
     delete the current record from the browse.  When finished, press
     [F10] to return to the edit menu.  Pressing [Esc] also will return you
     to the edit menu, but it will abort any change to the current record.

     Note:  The JKEY incremental search has recently been added to the
     browse command.  When performing a browse, press [Ctrl]-[J] to
     activate JKEY.  A search will begin on the current index.  Each new
     keystroke will be added to the search string and the record, closest
     matching to the current string, will be displayed.  You may press
     [BackSpace] to revise the search string, or press [Ctrl]-[Y] to clear
     it.  To abort JKEY, simply press [Ctrl]-[J] once again (or [Esc] to
     abort the browse).

                                Delete Function

     Pressing [D] will allow you to delete the currently displayed record.
     You will be prompted whether you are sure.  Pressing [Y] deletes the
     record from the database.

                                 Find Function

     Pressing [F] will invoke the find function.  This option is only
     available if a database is indexed.

     If invoked, you would type the key of the desired record, and press
     [Enter].  If found, the record would be displayed.  You could then
     delete it, or update it.


     Note:  The key doesn't have to be a complete description.  For
     incomplete keys, the find function will try to find the record with
     the closet matching key.

     Recently, wild-carding has been introduced into the [F]ind function.
     For example, suppose we have a customer file.  It has an index by last
     name.  When the find function prompts us, we could type:

          Last Name:  ..ll..

     In this example, we are searching for a customer whose last name
     contain a "ll".  In another example:

          Last Name:  ..en

     We are searching for a customer whose last name ends with "en".  In
     one more example:

          Last Name:  al..

     We are searching for a customer whose last name begins with "al".



                                     - Page 38 -







                                     Appendix A


     Here's where wild-carding get interesting.  Let's use the first
     example.  Say we find a customer whose last name contains a "ll".  If
     we use the [G]oto function, we get an extra option.  This option,
     called [C]ontinue, will allow us to find the next customer whose last
     name contains a "ll".

     The continue option will remain in effect until you perform another
     find.  It will search for the next wild-card occurrence no matter
     where you are in the database.  In that sense, think of wild-carding
     as an implicit record filter.

     Oh, a new feature has been added to wild-carding:  The triple period
     "...".  Like the double period "..", the triple period denotes wild-
     carding.  Using the triple, however, will also disable the current
     index during the search.

     You see, wild-card searches are a LOT faster when done on an unordered
     database.  So if you are looking for just one record or two records,
     don't care about viewing order, and are using a huge database, the
     triple period might save you valuable time.

                                 Goto Function

     Pressing [G] will create a pop-up menu.  This popup menu allows the
     user to display different records in the current database.  Press [F]
     for the first record in the database.  Press [L] for the last record.
     Press [N] for the next record.  Press [P] for the previous record.
     The goto window remains active until you press [Esc] or [Q] to quit.

     If the current database is indexed, order is defined by the toggle
     order function.  For example, if the current record is customer 5,
     pressing [N] will display customer 6.  If the index order is
     descending, however, pressing [N] will display customer 4.  See toggle
     index order.

     A new option, [W] for window, has been added.  Pressing [W] activates
     the goto window.  The user may then move the goto window to any
     location on the screen.  That location remains in effect for the
     duration of the editor.

     To move the window, press [Ctrl]-[F7].  The goto window border will
     flash.  Press any cursor key to move the window.  Press [Ctrl]-[F7] to
     stop the window from flashing.  Then press [Esc] to resume the normal
     goto prompts.

     Note:  You also may use a mouse to move the goto window.  Press [W].
     Place the mouse cursor on the border of the goto window.  Press the
     left button.  Drag the mouse cursor (and window) to the desired
     location.  Then, press the right button to resume the goto prompts.






                                     - Page 39 -







                                     Appendix A


                                 Help Function

     Pressing [H] will display a summary of commands used in the edit menu
     as in the following screen.  Pressing any key after that returns you
     to the edit menu.


         Command prompt

         [T]oggle Index -  Change Index used by [F]ind command
         Toggle [O]rder -  Current Index in Ascending/Descending Order

         [A]dd        -  Add a record to the current database
         [B]rowse     -  List all records a page at a time
         [D]elete     -  Delete the currently displayed record
         [F]ind       -  Search database for record with specified key
         [G]oto       -  Display the First, Last, Next, or Previous record
         [H]elp       -  Display help information
         [R]ecall     -  Recall Deleted Records
         [U]pdate     -  Update the currently displayed record
         [Q]uit       -  Return to calling program

         Common full screen keystrokes

         [ESC]        -  Abort operation, return to prompt/menu
         [HOME]       -  move cursor to beginning field
         [END]        -  move cursor to ending field
         [CTRL][HOME] -  repeat last input field completed
         [CTRL][END]  -  Complete operation, return to prompt/menu
         [F1]         -  Display Help text
         [F10]        -  Complete operation, return to prompt/menu
























                                     - Page 40 -







                                     Appendix A



                                Recall Function

     Pressing [R] allows you to recall a deleted record.  You will be
     presented with a browse window of all deleted records.  Simply locate
     the record to be recalled and press [Enter].

     Note:  If the current database has no deleted() index, you will be
     prompted for the record key (just like the find function).  Type the
     key of the record to be recalled and press [Enter].  If the deleted
     record is found, it is made active again.


                             Toggle Index Function

     For databases with multiple indices, the toggle option will be
     displayed.  The toggle option allows the user to change what index
     will be used with the [F]ind option.  The current index is displayed
     in parenthesis.

                             Toggle Order Function

     This option toggles the order of the current index.  The current order
     is displayed in parenthesis.

     For example, if the current order is ascending, pressing [O] will
     toggle the order to descending.  If the current index is by last name,
     then 'ALPHA' will come after 'BETA'  Pressing [O] again will change
     the current index back to ascending.

                                Update Function

     Pressing [U] allows you to update the currently displayed record.
     Like the add function, moving the cursor past the last field will
     complete the updating.  Pressing [Esc] will abort any update.

                                 Quit Function

     Finally, pressing [Q] will quit the editor.  You will be returned to
     the menu that invoked the editor.















                                     - Page 41 -







                                    Appendix A-1




     If you ever been on an input field, you may have noticed that pressing
     [Alt] displays a menu at the very top of the screen.  This is called
     the system menu, or sysmenu for short.  The system menu displayed is a
     customized version of the Foxpro sysmenu.  It contains a variety of
     functions and is available to all users.  The following describes only
     a few features available through the sysmenu.  For more information,
     see the Foxpro users manual.


                                  Sysmenu edit


     The sysmenu edit popup is very powerful.  It gives any input field a
     variety of edit functions.  For example, highlighting a section of
     text ([Shift] and cursor key) and pressing [Del] will delete this
     text.  But [Ctrl]-[C] would have copied this text into the clipboard.
     You would then use [Ctrl]-[V] to paste this text.

     Note:  The sysmenu edit popup provides a [Ctrl]-[U] option to undo a
     deletion, copy, cut, or paste.

     Another example:  Suppose you are editing a memo field.  The sysmenu
     edit popup provides a [Ctrl]-[F] option to find specified text.  This
     popup also provides a [Ctrl]-[G] option to repeat the last find.

     There are other functions in the sysmenu edit popup.  See the Foxpro
     users manual for details.


                               Foxpro Calculator


     Simply enter a numeric value on any input field.  Press [Alt]-[F4] to
     activate the Foxpro calculator.  The Foxpro calculator will display
     your numeric value.

     When you have a new calculated value, press [Ctrl]-[F4] to deactivate
     the calculator.  Your new numeric value will be placed into the
     current input field.

     Note:  If you just want the calculator, press [F4].  To close, mouse
     click on the upper left button of the calculator and select [Close].


                                Foxpro Calendar


     Simply enter a date on any input field.  Press [Alt]-[F5] to invoke
     the Foxpro calendar.  The Foxpro calendar will display the year,
     month, and day of the specified date.



                                     - Page 42 -







                                    Appendix A-1


     Select any desired date.  When you have a new date, press [Ctrl]-[F5]
     will deactivate the calendar.  Your new date will be placed into the
     current input field.

     Note:  If you just want the calendar, press [F5].  To close, mouse
     click on the upper left button of the calendar and select [Close].


                                Foxpro DOS Shell


     In Foxpro for DOS, the system pulldown menu provides a DOS shell.  If
     you are a system administrator, pressing [Alt]-[S] [O] brings up the
     DOS command window.  Type any desired DOS command.  Type 'EXIT' and
     press [Enter] to leave the DOS shell.


                                   Print Mode


     In Foxpro for windows, you can print the contents of the current
     window using the 'Print' option of the 'File' popup in sysmenu.  The
     'Print' option is equivalent to printing a report in non-draft mode.
     See system setup, printer codes.

     Note:  'Print' is not currently available in the Foxpro for windows
     runtime unit.


                                 Printer Eject


     Press [F7] for a page eject.  You will be prompted for a form feed.
     If you select [Y], a form feed will be sent to the current printer
     device.  See System Setup, printer codes.  This option is very useful
     for people with Laser Printers.

                                   Video Mode


     Press [Alt]-[V] for the video mode.  In Foxpro for DOS, a VGA screen
     will toggle between 25 and 43 line modes.  All subsequent windows will
     conform to the specified mode.  Very useful in displaying reports.

     In Foxpro for windows, [Alt]-[V] will display a font selector.  All
     sub-windows, to the current window, will conform to the specified
     font.  If you change the main menu window, the font becomes permanent
     to the user.







                                     - Page 43 -







                                     Appendix B


     The VCM System contains the following files:

     BACK     BAT   DBFS     PRG   EXPRMENU PRG   FOXERR   DBF
     FOXERR   FPT   FOXUSER  DBF   FOXUSER  FPT   HOST     BAT
     PKUNZIP  EXE   PKZIP    EXE   QVCM     DBF   QVCM     PRG
     Q_DATA   DBF   Q_EXPR   DBF   Q_EXPR   FPT   Q_EXPR   CDX
     Q_HELP   DBF   Q_HELP   FPT   Q_ID     CDX   Q_PHRASE DBF
     Q_PHRASE CDX   Q_TEMP   DBF   REMOTE   BAT   VCM      CDX
     VCM      DBF   VCM      MAN   VCM      PRG   VCMED    PRG
     VCMED1   PRG   VCMED2   PRG   VCMED3   PRG   VCMHIST  CDX
     VCMHIST  DBF   VCMPATH  CDX   VCMPATH  DBF   VCMPR    PRG
     VCMPR1   PRG   VCMPR2   PRG   VCMSYS   MEM   VCMSYS   PRG
     VCMUT    PRG   VCMUT1   PRG   VCMUT2   PRG   VCMUT3   PRG
     VCMUT4   PRG   VCMUT5   PRG   VCMUTA   PRG   VCMUTB   PRG
     VCMUTC   PRG   VCM_UP   PRG   SCR      CDX   SCR      DBF
     SCR      FPT   SCR      PRG   SCRPROC  PRG   UNBACK   BAT
     USER     CDX   USER     DBF

     The files with a .BAT extension are batch files.  Files with a .DBF
     extension are database files.  Files with a .CDX are Foxpro compound
     index files.  Files with a .PRG extension are Foxpro source files.
     The files with a .FXP extension are Foxpro object modules.  The files
     with a .FPT extension are Foxpro memo files.

     The VCM manual is stored in a file with a MAN extension.  A copy can
     be printed simply by typing "MANUAL" at the DOS prompt.

     USER.DBF is the User ID file database.  It is maintained by the VCM
     System.  It is indexed by VCM.CDX.  VCM.CDX has a tag by user id.

     VCM.DBF is the VCM file database.  It is edited by the option '1' of
     the edit menu.  It is indexed by VCM.CDX.  VCM.CDX has tags by host
     file path and file name.

     VCMHIST.DBF is the VCM History file database.  It is edited by the
     option '2' of the edit menu.  It is indexed by VCMHIST.CDX.
     VCMHIST.CDX has tags by host file path and file name.

     VCMPATH.DBF is the VCM Path database.  It is edited by the option '3'
     of the edit menu.  It is indexed by VCMPATH.CDX.  VCMPATH.CDX has tags
     by host file path and remote file path.

     SCR.DBF is the data dictionary.  It contains all the information
     defining the screen layouts.  SCR.FPT contains all the help text
     provided by the [F1] key.  It has one index, called SCR.CDX.  See
     Appendix D:  PROG.

     All Q*.* files belong, and are maintained, by the expression builder.
     See Appendix D:  Record Filters.

     VCMSYS.MEM is the VCM System memory file.  It contains system wide
     variables, including printer codes.



                                     - Page 44 -







                                     Appendix B


     FOXUSER.DBF is the foxuser resource file.  It contains all user
     attributes, including color.  See Appendix D.

     FOXERR.DBF is the Foxpro error file.  All major events are recorded
     here for debugging purposes.


















































                                     - Page 45 -







                                     Appendix B



                           Backup/Restore Data Files


     To insure the integrity of its data files, any major database should
     have a standardized backup procedure.  Data files should be
     periodically copied to a media, other than where they currently
     reside.  There is NO excuse for not developing a proper backup
     procedure.

     As a supplement, however, this application includes its own backup
     procedure.  To back up data, you must be in the application directory.
     At the DOS prompt type:

               BACK

     and press [Enter].  This command will copy all data files into a
     backup directory ('.\BAK').  In case of power failure, these backup
     files could be used to recover previous work.

     Restoring these backup files is simple.  To restore data, you must be
     in the application directory.  At the DOS prompt type:

               UNBACK

     and press [Enter].  This command restores all data up to the point you
     last invoked BACK.

     Note:  If you decide to store data files in a separate directory (See
     Appendix D), make sure the data directory has a '.\BAK' backup
     directory.  You would then execute BACK and UNBACK from your data
     directory.  For convenience, you might consider coping BACK.BAT and
     UNBACK.BAT into your data directory.

     Warning:  If you ever run into a problem with this application, NEVER
     invoke the "BACK" command without first resolving the problem.  If a
     data file is corrupt, using "BACK" would only copy this corrupted file
     over a good backup file.

















                                     - Page 46 -







                                     Appendix C


     In the course of normal events, you shouldn't see any error messages.
     But events can happen to cause an error message.  The most common
     events are:  Verification, disk space used up, printer not ready,
     multi-user, or syntax error.


                                  Verification


     When you start your application, all databases files are inspected.
     If a database file doesn't exist, it is created.  If a database file
     is missing a field, it is added.  If a field is not the correct
     length, it is lengthened.  If a structural index tag is missing or not
     in the correct order, the entire CDX file is rebuilt.

     Of course, the verification could fail.  There are many reasons for
     verification to fail.  On a network, someone could be using the
     database file(s) you're trying to update.  Or, you might not have the
     access permission to create/update database file(s) in your data
     directory.  Whatever the reason, remember that verification fails only
     when a database file needed to be changed, but could not be updated.
     In such an event, consult your system administrator.

                                Bad Record Count

     If a database file has a bad record count, the verification process
     will try to repair it.  If the database file could not be repaired,
     however, a new (and empty) database file is created.  The corrupted
     DBF file is renamed as a BAK file.  Any associated FPT file will be
     renamed as a TBK file.

     Please keep this feature in mind when you invoke your own database
     repair utility.  An empty database file doesn't necessarily mean you
     lost your data.  Your corrupted data probably resides in BAK and TBK
     files.  But, depending on the damage, you may need the header of the
     empty database file to repair your corrupted data.

     Before any repairs, I suggest creating a floppy disk or tape backup of
     your BAK and TBK files.  In fact, it might be best just to backup all
     the files found in your data directory.

     Once repairs are complete, simply rename the repaired BAK file as the
     DBF file.  Rename any associated TBK file as a FPT file.  Oh, and
     remove the associated CDX file (will be rebuilt the next time you
     start the application).










                                     - Page 47 -







                                     Appendix C




                                   Disk Space


     If ever you see data records that look like garbage, you may have bad
     sectors on your hard disk.  Ask your system administrator to take a
     look at it.  The usual procedure is to back up all programs/data, and
     reformat the hard disk.  Any bad sectors found should be locked out
     and should no longer cause a problem.

     Bad data can result from lack of free space on the hard drive.  While
     you cannot start this application without a minimum amount of free
     space, it's always possible you might have used a routine that filled
     up your hard drive.  If this be the case, exit the application.  If
     you cannot get back into the application, due to lack of free space,
     have your system administrator remove all unused temporary files.  If
     you still cannot get back in, you might have to restore backup files.


                               Printer not Ready


     If you're printing a report and the printer is not on, you will get a
     message:

          Printer not ready.
          Press anything to retry, 'Q' to quit"

     Simply turn on your printer, and press any key to retry.  Your report
     should start to print.  Pressing "Q" would have aborted the report and
     returned you to the main menu.

     If you retry and still get "Printer not ready", you may have to
     perform the following DOS command:

          MODE LPT1,,P

     This command tells DOS to perform an infinite number of retries on the
     print device "LPT1".  Depending on you machine, you may also have to
     increase the Foxpro printer time-out.  See Appendix D:  TIME.














                                     - Page 48 -







                                     Appendix C




                               Multi-User Errors


     If you running this application under the multi-user mode, you may be
     presented with two different type of error messages.  Both types have
     to do with file locking.

     For example, you may be updating a database record.  In the meantime,
     however, somebody else may have already updated that record.  When
     your update is complete, you will receive the message:

          Current record has been altered

     In that case, review the updated record and try the update again.

     Another kind of message occurs while you are performing some kind of
     transaction processing.  If you need a record that somebody else has
     locked out, you will receive the message:

          Waiting for access, press [ESC] to abort

     In this case, just wait.  Most of the time, the record you need will
     be quickly released.


                                  Syntax Error


     The last kind of problem is a syntax error.  You shouldn't ever see
     one.  In case you do, however, you will be prompted:

          [I]gnore, [R]etry, [S]uspend, or [Q]uit to Main Menu.

     Unless you're a system administrator, your best bet is to press [Q] to
     Quit to Main menu.  Pressing [Q] will automatically log the error into
     the Foxpro error file (FOXERR.DBF).

     Don't forget to tell your system administrator about the error.  As
     the author, I'll want a copy of your FOXERR.* files to determine the
     type of error that occurred and to possibly correct it.













                                     - Page 49 -







                                     Appendix D


     To use this Foxpro application, each user needs a resource directory.
     A resource directory contains all the files needed to configure this
     application.  On a single-user system, or a network with a local hard
     drive, the resource directory will usually be the Foxpro runtime unit
     directory.

     This appendix will first explain the Foxpro runtime unit.  What's in
     it and how Foxpro determines the resource directory.  From there, this
     appendix will explain the resource directory.  What files are in this
     directory and how to configure them for this application.


                              Foxpro Runtime Unit


     The Foxpro runtime unit contain all the files necessary to run this
     application.  Since many Foxpro applications require the same runtime
     unit, these files are usually stored in their own directory (typically
     C:\FOXRUN).  On a network, the Foxpro runtime unit should be installed
     on each user's local hard drive.  It could, however, be shared among
     users with no local hard drive.

     The runtime unit consists of *.ESL files, *.ESO files, FOXSWAP.COM,
     and FOXR.EXE.

     Foxpro for DOS runtime comes with two versions.  The standard
     (FOXD*.ES?) and the extended (FOXDX*.ES?).  The standard version is
     for machines with only expanded (EMS) memory or less than three
     megabytes of extended memory.  The extended version is for machines
     with three or more megabytes of extended memory.

     Note:  FOXSWAP.COM is used only with the standard version to invoke
     large DOS applications.


                                    FOXR.EXE


     FOXR.EXE is the Foxpro for DOS startup module.  It allows Foxpro to
     launch an application.  FOXR.EXE also determines where the user
     resource directory is located.  Example:

          C:\FOXRUN\FOXR.EXE -cC:\FOXRUN\CONFIG.FP -m2612 vcm

     In this example, FOXR.EXE was called from the runtime unit directory.
     It executed the application startup module VCM.FXP.  The -c option
     defined C:\FOXRUN\CONFIG.FP as the Foxpro configuration file.  It is
     the configuration file that determines the user's resource directory.







                                     - Page 50 -







                                     Appendix D


     FOXR.EXE also determines which version of Foxpro, standard or
     extended, to run.  Normally, it takes three megabytes of extended
     memory to invoke the extended version.

     In the last example, however, the -m option was used to reduce the
     amount of extended memory required to invoke the extended version.  In
     this case, only 2.6 megabytes was needed.


                                   FOXRW.EXE


     FOXRW.EXE is the Foxpro for Windows version of FOXR.EXE.  It allows
     the Foxpro for Windows runtime (FOXW*.ES?) to launch an application.
     The same rules and parameters of FOXR.EXE apply to FOXRW.EXE.

     Before continuing, it should be noted.  All the files in the runtime
     unit are self contained.  You need not add a C:\FOXRUN or a C:\FOXRUNW
     to your DOS PATH statement.


                                   CONFIG.FP


     As stated earlier, the CONFIG.FP file (CONFIG.FPW in Foxpro for
     windows) determines the user's resource directory.  It can also be
     used to optimize Foxpro.  The following is the basic CONFIG.FP file
     layout:

               _FOXDOC   = ''
               _FOXGRAPH = ''
               _GENGRAPH = ''
               BELL = OFF
               COLOR SET = FOXDEF
               DEVELOPMENT = OFF
               FILES = 45
               INDEX = NDX
               MVARSIZE = 20
               MVCOUNT = 512
               MEMLIMIT = 40,1024,4096
               RESOURCE = C:\FOXRUN
               RESOURCE = ON
               SAFETY = OFF
               STATUS = OFF
               TALK = OFF

     The following section will describe the most important commands in the
     CONFIG.FP.







                                     - Page 51 -







                                     Appendix D


                                   COLOR SET


     This is the default color set.  Example:  COLOR SET=FOXDEF.  This
     color set used to start your application.  It is also the color set
     used to store any color set changes.  See Change Color Set, provided
     in the System Setup menu.

     If no color set is specified in your CONFIG.FP, the default is DEFAULT
     for DOS, FOXDEF for Windows.


                                      EMS


     The standard version of Foxpro requires expanded memory.  You need at
     least three megabytes of extended memory to run the extended version
     of Foxpro.  If you only have expanded memory, add the following
     command to CONFIG.FP:

               EMS = ON

     If your expanded memory doesn't work with Foxpro, it probably doesn't
     conform to the LIM 4.0 specification for EMS.  In that case, replace
     the EMS on command with the following:

               EMS64 = OFF
               EMS = ON

     These commands allow Foxpro to use EMS memory, but only for file I/O.


                                    MEMLIMIT


     If you are unable to run Foxpro for windows, due to insufficient
     memory, add a MEMLIMIT statement to your CONFIG.FPW file.  The syntax
     for this statement is MEMLIMIT=%,min,max where % is a calculated
     amount based on available memory and min and max represent actual
     minimum and maximum allocations.

     For example, specifying MEMLIMIT=80,1024,4096 allocates 80 percent of
     your system's available memory to Foxpro with a minimum allocation of
     1024K and a maximum of 4096K.











                                     - Page 52 -







                                     Appendix D




                                    PROGWORK


     If you have at least a 450 kilobyte ramdisk, you can add the following
     command:

               PROGWORK = G:\

     This command will place program cache on drive G.  There are similar
     commands you can use to further optimize Foxpro.  If you are
     interested, refer to the Foxpro user guide.


                                    RESOURCE


     This command defines the user resource directory.  For single users,
     or network users with local hard drives, the resource directory would
     also be the runtime unit directory.  Example:

               C:\FOXRUN\FOXR.EXE -CC:\FOXRUN\CONFIG.FP VCM

     Where C:\FOXRUN is the local copy of the runtime unit and the
     CONFIG.FP file.  VCM would be, of course, the startup procedure to our
     application.  The CONFIG.FP file would contain the commands:

               RESOURCE = C:\FOXRUN
               RESOURCE = ON


     In the case of a network with no local hard drive, a work station
     would be invoked as:

               K:\FOXRUN\FOXR.EXE -CK:\USER1\CONFIG.FP VCM

     Where K:\FOXRUN contains the shared copy of the runtime unit and
     K:\USER1 contains the CONFIG.FP.  The CONFIG.FP would contain:

               RESOURCE = K:\USER1
               RESOURCE = ON

     Where K:\FOXRUN is defined as the user resource directory.

     Note:  If a runtime unit is to be shared, all *.ESL, *.ESO, FOXR.EXE
     and/or FOXRW.EXE must be marked as read-only.  The normal
     installation, however, should have already done this.







                                     - Page 53 -







                                     Appendix D


                                      TIME


     Establishes the amount of time that Foxpro waits for the print device
     to accept a character.  If the printer is not ready, this value
     dictates the number of retries that Foxpro will make to the print
     device.  If the retry count is exhausted, Foxpro issues the error
     "Printer not ready. Retry? (Y/N)".  The value of TIME may range from 1
     to 1,000,000 retries.  The default is 6,000.














































                                     - Page 54 -







                                     Appendix D


                                   FOXPRO.INI


     Another resource directory file is FOXPRO.INI.  In the past, this
     Foxpro application was configured using DOS environment variables.
     For example, the DOS command SET MULT=YES would set this application
     into multi-user mode.

     While DOS environment variables are still accepted, the preferred way
     is to add commands to a [GetEnv] section of the FOXPRO.INI file.  The
     following is a basic FOXPRO.INI file layout:


          [FoxPro]
          Zoomed=0
          Row=0
          Column=0
          Height=402
          Width=648
          FontName=FOXFONT
          FontStyle=0
          FontSize=9
          
          [GetEnv]
          FontName=FoxFont
          FontStyle=N
          FontSize=9
          Mult=yes
          Recall=yes


     Note:  The [Foxpro] section is used only by Foxpro for Windows and
     then, only from the FOXPRO.INI stored in the windows directory.

     The following is a list of FOXPRO.INI [GetEnv] commands:


                                      ADD


     In every editor, by default, when you are finished adding a new
     record, you will be prompted for a another record.  This keeps
     happening until you press [Esc].  By specifying ADD=NO, the add mode
     will prompt you for a new record only once.  Just like the update
     mode.

     This option allows you to review a new record before adding the next
     record.







                                     - Page 55 -







                                     Appendix D


                                     BORDER


     The BORDER command allows the user to define the border characters of
     all displayed windows and popups.  Available options are:


          BORDER = [SINGLE | DOUBLE | PANEL | NONE
                   | <border string1>,  <border string2>


     SINGLE:   Creates a single-line border.

     DOUBLE:   Creates a double-line border.  In Foxpro for Windows, this
     option creates a panel effect.

     PANEL:    Creates a wide border.

     NONE:     Suppresses the border entirely.

     <border string1>[, <border string2>]:   Use the border definition
     strings <border string1> and <border string2> to create your own
     borders.  <border string1> is used for menus, popups and boxes and for
     the current output window.  <border string2> specifies the border that
     appears when output isn't being directed to the window.  <border
     string2> doesn't affect boxes or popups.

     A border definition string is a set of ASCII character values defined
     [<1>] [, [<2>] [, [<3>] [, [<4>] [, [<5>] [, [<6>][, [<7>] [,
     [<8>]]]]]]]].  The border string entries 1 through 8 designate the
     top, bottom, left side, right side, upper-left corner, upper-right
     corner, lower-left corner and lower-right corner of the border,
     respectively.  If you include just one ASCII value in the border
     string definition, the entire border is drawn using that one
     character.  Note:  Border strings are ignored in Foxpro for Windows.

     For example, adding the following command to the [GetEnv] section of
     your FOXPRO.INI file:

               BORDER=SINGLE

     ..will draw single line border windows.













                                     - Page 56 -







                                     Appendix D


                                      DATA


     All application data files are assumed in the current directory unless
     the command DATA is specified.  Example:

               DATA=C:\DATA\

     Note: Data files include *.DBF, *.CDX, and *.FPT.  Q*.* are expression
     builder files (see Record Filters).  SCR.* are data dictionary files
     and belong in the program directory (see PROG).


                                    FONTNAME


     In Foxpro for Windows, pressing [Alt]-[V] allows the user to change
     fonts.  When a font is changed at a particular menu, all sub-menus
     will use that font.  If the font is changed at the main menu, the new
     font is stored in the [GetEnv] section of FOXPRO.INI.  When the
     application is restarted, the new font will then be used.

     The following command will define the name of the font:

               FONTNAME=FOXFONT

     ...where Foxfont is the name of the font.


                                    FONTSIZE


     In Foxpro for Windows, the following command will define the startup
     font size:

               FONTSIZE=9

     ..where '9' is 9 point.


                                   FONTSTYLE


     In Foxpro for Windows, the following command will define the style of
     the startup font:

               FONTSTYLE=N

     ..where 'N' is normal, 'I' defines italic, and 'B' for bold.  See the
     Foxpro command DEFINE WINDOW for a list of possible styles.





                                     - Page 57 -







                                     Appendix D


                                      HOST


     VCM normally comes up in remote user mode.  To make it run in Host
     user mode, add the following to your [GetEnv] section of FOXPRO.INI:

               HOST=YES

     To make VCM run in remote user mode, simply remove this command from
     your [GetEnv] section.


                                      INIT


     The INIT command allows the user to perform system administration
     functions.  These functions provide a measure of system control and
     are not needed for day to day activities.

     To invoke this system administration function, add the following
     command to the [GetEnv] section of your FOXPRO.INI file:

               INIT=YES

     When you run application again, you will notice new options.  If you
     are running on a network, an option M will appear on the main menu.
     Option 'M' allows you to toggle between Multi-user and single-user
     modes.  Some system administration functions can only be provided in
     single-user mode.


                                      LAST


     This application normally resets all browse sessions.  The browse
     layout, however, can be saved by adding the following command to your
     [GetEnv] section of the FOXPRO.INI file:

               LAST=YES

     With this command, fields may be moved around or resized.  Partitions
     may be split or separated.  All these preferences will be saved and
     will be in effect the next time you perform the browse.


                                      MULT


     This application normally comes up in single user mode.  To make it
     wake up in Multi-user mode, add the following command to your [GetEnv]
     section of the FOXPRO.INI file:

               MULT=YES


                                     - Page 58 -







                                     Appendix D


                                      PROG


     All application program files and all data dictionary files are
     assumed in the current directory unless the FOXPRO.INI command PROG is
     specified.  Example:

               PROG=D:\PROG\

     Note: Program files include *.PRG, *.FXP, and SCR.*.


                                     RECALL


     The application normally reuses deleted records.  That is, deleted
     records are blanked out to be reused the next time you add a record.
     You can recall deleted records with the following FOXPRO.INI command:

               RECALL=YES

     When recall is in effect, deleted records are not blanked out.  You
     will be provided with an extra recall option on all editors.  Like the
     find option, recall prompts the user for a record.  If the deleted
     record is found, it becomes active again.

     Note:  If the current database has a deleted() index, deleted records
     are NEVER blanked out.  When recall is in effect, you will be
     presented with a browse of all deleted records.  Select the desired
     record and press [Enter].


                                    REFRESH


     In a network environment, is it possible that the records you are
     currently viewing have (via BROWSE) changed.  Other users may have
     edited or even deleted these records.  Foxpro, therefore, must
     periodically refresh it's data buffers.  How often this refresh will
     occur is set by the FOXPRO.INI variable REFRESH.  Example:

               REFRESH=15

     In this example, the refresh rate is set to 15 seconds.  The default
     is 30 seconds.










                                     - Page 59 -







                                     Appendix D



                                    SYSMENU


     In Foxpro for DOS, the system menu is normally hidden.  You must press
     the [Alt] key to wake it up.  You can have the system menu always
     displayed with the following FOXPRO.INI command:

               SYSMENU=SHOW


     In Foxpro for Windows, the system menu is normally displayed.  You can
     have the system menu hidden with the following FOXPRO.INI command:

               SYSMENU=HIDDEN


                                      TEMP


     All temporary files are assumed in the current directory unless the
     FOXPRO.INI command TEMP is specified.  Example:

               TEMP=C:\TEMP

     If you have a large enough ramdisk, setting TEMP to the ramdisk should
     improve performance.

     Note:  DOS environment variables take precedent over [GetEnv]
     commands.  That is, a DOS environment variable TEMP is used before a
     [GetEnv] command TEMP.


                                      TERM


     In the very near future, Foxpro will be available for many different
     systems.  To remain compatible, the FOXPRO.INI command TERM was
     created.  If TERM does not exist, or if TERM is equal to ANSI, then
     the system is considered 100% ANSI compatible.  That is, function keys
     [F1]-[F10] exist, [Esc] exists, and the ability to use a mouse exists.
     Example:

               TERM=ANSI

     The file CONFIG.FP stores commands to configure Foxpro.  The [GetEnv]
     section of the file FOXPRO.INI stores commands to configure this
     application.  Other resource directory files include FOXUSER.*, *.MEM
     files, and Q*.* files.  The following describe each of these files:






                                     - Page 60 -







                                     Appendix D


                                  FOXUSER.DBF


     The Foxpro resource file (FOXUSER.DBF) stores all the attributes of
     the user.  What color sets the user desires and how to display browse
     windows.  It also stores certain preferences required by this
     application.  For instance, all files with a "TMP" extension should
     have word wrap enabled and backup disabled.  All files with a "TXT"
     extension should have word wrap disabled and backup disabled.

     The Foxpro resource file stores all the color sets available to
     Foxpro.  If you wish to improve the appearance of your menus, make
     sure "enabled opt." in your user menu (color set 2) is set to the same
     color as your "@ SAY".

     Note:  Foxpro for DOS uses the default color set "DEFAULT".  Foxpro
     for windows use the default color set "FOXDEF".


                                  FOXUSER2.DBF


     The second Foxpro resource file (FOXUSER2.DBF) has the same file
     structure as the Foxpro resource file (FOXUSER.DBF).  Unlike
     FOXUSER.DBF, however, color sets stored in the memo field 'DATA' are
     in ASCII text.

     The text layout is simple.  Twelve lines for the twelve color schemes
     used by this application.  Each line contain ten color pairs.  A color
     pair "W*/B+", for example, would denote a white foreground, blue
     background ("*" denotes blinking and "+" denotes intensity).  For a
     description of color pairs used within a scheme, check the color
     picker portion of the Foxpro manual.

     Note:  As long as the field 'UPDATED' has a more recent date, the
     color set from FOXUSER2.DBF will override the color set found in
     FOXUSER.DBF.


















                                     - Page 61 -







                                     Appendix D


                                 Printer Codes


     Printer codes are maintained by the system setup menu and are stored
     in a ???SYS.MEM memory file.  This memory file is stored in user's
     resource directory.

     On a network, each user will have his/her own set of printer codes.
     To retain a common set of printer codes, allow one user to maintain
     printer codes in the data directory (see DATA).  Then, simply delete
     ???SYS.MEM files from each user's resource directory.  Each user will
     get a fresh copy of printer codes, from the data directory, the next
     time they run the application.


                                 Record Filters


     Record filter files belong, and are maintained, by the expression
     builder.  These include Q*.DBF, Q*.FPT, Q*.CDX.  Record filters are
     stored in the user's resource directory.

     On a network, each user will have his/her own set of record filters.
     To retain a common set of record filters, allow one user to maintain
     record filters in the data directory (see DATA).  Then, simply delete
     all Q*.* files from each user's resource directory.  Each user will
     get a fresh copy of record filters, from the data directory, the next
     time they run the expression builder.


                              Configuring Sideways


     If you are using the sideways utility from Funk software, there are a
     couple of steps necessary configure it.  First, you can select the
     desired printer by running SWSETUP.COM.  This utility will modify
     SIDEWAYS.COM.  After selecting the desired printer, copy SIDEWAYS.COM
     to the user's resource directory.

     Note:  If you ever want to know where your resource directory is
     located, select the option "all about.." in the system setup menu.

     If you need to modify the font proportions, go into your resource
     directory and run SIDEWAYS.COM (no parameters).  A screen will appear,
     displaying all the current setup values.  Adjust these values and
     press [F9] to create the default file, SIDEWAYS.DFT.

     Note:  If you change your resource directory, create a new
     SIDEWAYS.DFT.  Among other things, this file contains it's own
     location.  Moving an DFT file can result in a "file not found" error
     message.




                                     - Page 62 -







                                      GLOSSARY


     ANSI  -  American National Standards Institute.  A standard for both
          screen output and keyboard input.

     Arrow Keys  -  Equivalent to cursor keys.  Those keys on the keyboard
          labeled with arrows.

     ASCII  -  American Standard Code for Information Interchange.  A
          standard 7 bit code used to represent data.

     Batch File  -  A file containing multiple DOS commands.  These
          commands are executed by DOS, one at a time, as if typed by the
          user.

     Byte  -  A unit of information.  In text form, equivalent to an ASCII
          character.

     Code  -  Program code.  Another way of saying program instructions.

     Compiler  -  A program that converts program code from one form to
          another, usually more primitive, form.  The converted code is
          then ready for execution.

     CONFIG.FP  -  The Foxpro configuration file.  This file tells Foxpro
          where is find the resource file.  On a network, there is a one
          copy for each Foxpro user.

     CONFIG.FPM  -  The Foxpro for Macintosh configuration file.

     CONFIG.FPW  -  The Foxpro for windows configuration file.

     Cursor  -  A flashing character on the screen.  It indicates where
          typed text will be next placed.

     Cursor Keys  -  Equivalent to arrow keys.  Those keys on the keyboard
          labeled with arrows.

     Data Dictionary  -  A database file that defines the input/output to
          database files in an application.

     dBASE  -  Popular database management language.  The software package
          dBASE III+ is an interpreter for dBASE code.

     dVERSION  -  A program that translates dBASE code, conditional upon
          specified parameters, into executable dBASE code.

     Disk  -  A unit where information is stored.  There are two major
          types: hard disk, and floppy disk.

     Disk Error  -  An error occurring when a program is unable to read or
          write properly to a disk.

     Diskspace  -  A unit of how much room is available on a drive.  It is
          usually measured in bytes.


                                     - Page 63 -







                                      GLOSSARY


     DOS  -  Disk Operating System.

     EMS  -  Refers to expanded memory.  Most 80286 computers have expanded
          memory.  80386 computers have extended memory.  There are,
          however, 80386 software drivers (QEMM for example), that can
          offer either extended or expanded memory.

     Extended  -  Extended memory.  80386 (or better) computers have
          extended memory.  The extended version of Foxpro needs at least
          three megabytes of extended memory.  The standard version of
          Foxpro requires expanded memory.

     Filespec  -  any DOS filename.ext including catalog names, passwords,
          etc.

     Floppy Disk  -  A self contained unit where information is stored.
          Depending on the type, floppy disks are easily transportable.
          Sometimes called a diskette.

     Foxbase  -   A dBASE III plus compatible language.

     Foxpro  -   A dBASE IV compatible language.

     FOXERR.DBF  -  The Foxpro error file.  Every major error event is
          recorded in this file.

     FOXUSER.DBF  -  The Foxpro resource file.  This file stores all the
          attributes of the user.  It also stores all the color sets
          available to Foxpro.  On a network, there is a one copy for each
          Foxpro user.

     Hard Disk  -  A self contained unit where information is stored.
          Usually not removable.

     HELP  -  A facility that provides on-line assistance in the use of a
          given program.

     Highlight  -  A form of a cursor, where an entire field is considered
          the cursor.

     Interpreter  -  A program that executes language code.  Whereas a
          compiler translates program code to executable code, an
          interpreter translates a single line of program code before
          executing it.

     Kilobyte  -  One kilobyte of memory equals 1,024 bytes.

     Megabyte  -  One megabyte of memory equals 1,024,000 bytes.

     Multi-user  -  When more one than one person is capable of
          accessing/updating the same database at the same time.

     MS-DOS  -  Microsoft Disk Operating System.


                                     - Page 64 -







                                      GLOSSARY


     PKZIP.EXE  -  PKWare's data compression utility.  Creates ZIP files.
          License for use within VCM.

     PKUNZIP.EXE  -  PKWare's data expansion utility.  Expands ZIP files.
          License for use within VCM.

     Sideways  -  A DOS Utility that will print text up and down instead of
          across the paper.

     Source Code  -  What a translator/compiler takes in as input.

     Syntax  -  The rules for the arrangement of statements in a
          programming language










































                                     - Page 65 -







                                        Index


     *.ESL  50                            CONFIG.FP  50, 51, 63
     *.ESO  50                            CONFIG.FPM  63
     .BAT  44                             CONFIG.FPW  51, 52, 63
     .CDX  44                             Configuring Sideways  62
     .DBF  44                             Copyright/License/Warranty  2
     .FPT  44                             Create new VCM File  32
     .FXP  44                             Create/Update VCM Path File  31
     .PRG  44                             Creating HOST.ZIP  15
     [Alt]-[F4]  42                       Creating REMOTE.ZIP  10
     [Alt]-[F5]  42                       CSV  23
     [Alt]-[V]  43                        Cursor  36, 63
     [Ctrl]-[F4]  42                      Cursor Keys  63
     [Ctrl]-[F5]  43                      Customizing Color Sets  28
     [Ctrl]-[Home]  37                    DATA  57
     [Ctrl]-[J]  38                       Data dictionary  44, 59, 63
     [Ctrl]-[N]  38                       Database of source code  5
     [Ctrl]-[T]  38                       DBASE  63
     [Ctrl]-[Y]  38                       DBASE IV  1
     [End]  36                            DBF  23
     [Esc]  37                            Delete Function  13, 38
     [F1]  36                             Disk  63
     [F10]  38                            Disk Error  63
     [F4]  42                             Disk Space  48
     [F5]  43                             Diskspace  63
     [F7]  43                             Display/Print Manual  30
     [Home]  36                           DOS  5, 64
     [Shift]-[TAB]  37                    Draft mode  27
     [TAB]  37                            DVERSION  30, 63
     ADD  55                              Edit Data Path/File Names  29
     Add Function  12, 36                 Editor  5
     All About...  29                     EMS  50, 52, 64
     ANSI  60, 63                         Excluded File List  30
     Appendix A  35                       Expanded  52
     Appendix A-1  42                     Expression builder  5, 25
     Appendix B  44                       Extended  1, 52, 64
     Appendix C  47                       FC  23
     Appendix D  50                       File Comparison  23
     Arrow Keys  63                       Filespec  64
     ASCII  63                            Filter  24, 25
     BACK  46                             Find Function  13, 38
     Backup/Restore Data Files  46        Floppy Disk  64
     Bad Record Count  47                 Font  27, 43
     Batch File  63                       FONTNAME  57
     BORDER  56                           FONTSIZE  57
     Browse Function  13, 37              FONTSTYLE  57
     Byte  63                             Foxbase  64
     Change Color Set  28                 FOXERR.DBF  28, 45, 49, 64
     Check Parameter Code  22             Foxpro  1, 5, 64
     Check Translated Code  21            Foxpro Calculator  42
     Client Overview  7                   Foxpro Calendar  42
     Code  63                             Foxpro DOS Shell  43
     COLOR SET  52                        Foxpro for DOS  43
     Compare Host to Remote  22           Foxpro for windows  43, 52, 55,
     Compiler  63                             57

                                     - Page 66 -







                                        Index


     Foxpro runtime unit  8, 50           Print Mode  43
     Foxpro runtime unit directory        Print VCM Files  19
         50                               Printer Codes  27, 62
     FOXPRO.INI  55                       Printer Control Codes  26
     FOXR.EXE  50                         Printer Device  26
     FOXRUN  50                           Printer Eject  43
     FOXRW.EXE  51                        Printer Name  26
     FOXSWAP.COM  50                      Printer not Ready  48
     FOXUSER.DBF  28, 45, 61, 64          Printing VCM Edit List  19
     FOXUSER2.DBF  28, 61                 Printing VCM History Edit List
     FRX  23                                  20
     GLOSSARY  63                         Printing VCM Path Edit List  21
     Goto Function  13, 39                Problems & Suggestions  28
     Hard Disk  64                        PROG  59
     HELP  64                             Program files  5
     Help Function  13, 40                Programmer Overview  7
     Highlight  64                        PROGWORK  53
     Host  7, 58                          Purge Backup.$$$ files  33
     Host Restart  15                     Q*.*  44
     Host Start-up  8                     Quit  18, 23, 30
     HOST.ZIP  7, 15                      Quit Function  14, 41
     Included File List  29               Quit to DOS  34
     Index  66                            Ramdisk  60
     INIT  58                             Rebuilding Indices  32
     Initializing Databases  32           RECALL  59
     Interpreter  64                      Recall Function  41
     Introduction  5                      Record filter  5, 24, 25
     JKEY  38                             Record Filters  62
     Kilobyte  64                         REFRESH  59
     Laser Printers  43                   Remote  7
     LAST  58                             Remote Start-up  10
     LIM 4.0  52                          REMOTE.ZIP  7, 10, 15
     Macintosh  6                         RESOURCE  53
     Maintaining VCM records  16          Resource directory  50
     MANUAL  44                           Rollback VCM File  32
     Megabyte  64                         SCR.DBF  44
     Megabytes  1                         SCX  23
     MEMLIMIT  52                         Security clearance  7
     Memo  28, 44                         Sideways  27, 65
     MNX  23                              SIDEWAYS.COM  62
     MODE  48                             SIDEWAYS.DFT  62
     MS-DOS  1, 64                        Source code  5, 65
     MULT  58                             Straight lines per page  27
     Multi-user  26, 64                   SWSETUP.COM  62
     Multi-User Errors  49                Syntax  65
     Network  26, 50, 58                  Syntax Error  49
     Non-draft  43                        Sysmenu  42, 60
     Non-draft mode  27                   Sysmenu edit  42
     Normal Operations  15                System administration  58
     Notation Conventions  6              System administrator  8, 17, 28,
     P_CODES.DBF  26                          34, 43, 47, 48, 49
     PKUNZIP.EXE  65                      System Setup  24
     PKZIP.EXE  65                        System Startup  7
     Preface  1                           TABLE OF CONTENTS  3

                                     - Page 67 -







                                        Index


     TEMP  60
     TERM  60
     TIME  54
     Toggle Index Function  13, 41
     Toggle Order Function  13, 41
     UNBACK  46
     Update Function  14, 41
     Updating a VCM Path Record  14
     Updating VCM Paths  11
     User id  8
     User-id  5
     USER.DBF  10, 44
     Utilities  31
     VCM  1, 5
     VCM.DBF  10, 16, 23, 44
     VCMHIST.DBF  10, 16, 44
     VCMPATH.DBF  10, 16, 44
     VCMSYS.MEM  44
     Verification  47
     Version Control  30
     Video Mode  43
     Wild-carding  38
     Window  5
     ZIP Files  16































                                     - Page 68 -



